/*!
 * Copyright (c) Microsoft
 * All rights reserved.
 * MIT License
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 */
(function(e){var t={};function r(n){if(t[n])return t[n].exports;var i=t[n]={exports:{},id:n,loaded:false};e[n].call(i.exports,i,i.exports,r);i.loaded=true;return i.exports}r.m=e;r.c=t;r.p="";return r(0)})([function(e,t,r){"use strict";var n=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r]};return function(t,r){e(t,r);function n(){this.constructor=t}t.prototype=r===null?Object.create(r):(n.prototype=r.prototype,new n)}}();var i=this&&this.__decorate||function(e,t,r,n){var i=arguments.length,o=i<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,r):n,a;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")o=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)if(a=e[s])o=(i<3?a(o):i>3?a(t,r,o):a(t,r))||o;return i>3&&o&&Object.defineProperty(t,r,o),o};Object.defineProperty(t,"__esModule",{value:true});var o=r(19);var a=r(6);var s=r(7);var u=r(183);var l=powerbi.data;var c=r(85);var f=r(79);var d=r(80);var p=r(192);var h=o.logger("essex.widget.AttributeSlicerVisual");var v=r(180);var g=r(76);var y="mousedown mouseup click focus blur input pointerdown pointerup touchstart touchmove touchdown";var m=function(e){n(t,e);function t(t,r){if(t===void 0){t=false}var n=e.call(this,"Attribute Slicer",t)||this;n._onSelectionChangedDebounced=a.debounce(function(e){h("onSelectionChanged");var t=e.map(function(e){return e.match}).join(", ");var r=t&&t.length?"Select "+t:"Clear Selection";n.state.selectedItems=e;n.writeStateToPBI(r)},100);n.state=p.default.create();r.element=s(r.element);n.init(r);return n}Object.defineProperty(t.prototype,"template",{get:function(){return"<div></div>"},enumerable:true,configurable:true});t.prototype.init=function(t){e.prototype.init.call(this,t);this.host=t.host;this.selectionManager=this.host["createSelectionManager"]();this.propertyPersister=o.createPropertyPersister(this.host,100);var r=v&&v.locals&&v.locals.className;if(r){this.element.addClass(r)}this.element.on(y,function(e){return e.stopPropagation()});var n=s("<div>");this.element.append(n);var i=new c.AttributeSlicer(n);i.serverSideSearch=true;i.events.on("loadMoreData",this.onLoadMoreData.bind(this));i.events.on("canLoadMoreData",this.onCanLoadMoreData.bind(this));i.events.on("selectionChanged",this.onSelectionChanged.bind(this));i.events.on("searchPerformed",this.onSearchPerformed.bind(this));i.showSearchBox=false;this.mySlicer=i};t.prototype.setDimensions=function(e){if(this.mySlicer){this.mySlicer.dimensions=e}};t.prototype.updateWithType=function(t,r){e.prototype.updateWithType.call(this,t,r);this.isHandlingUpdate=true;try{h("Update",t);if(r===o.UpdateType.Resize){this.setDimensions(t.viewport)}var n=this.dataView=t.dataViews&&t.dataViews[0];if(n&&n.categorical){var i=p.default.createFromPBI(n);this.loadDataFromVisualUpdate(r,t.type,n,i);if(!c.isStateEqual(i,this.state)){var a=this.state;this.state=i;this.mySlicer.state=this.state;var s=this.state,u=s.labelPrecision,l=s.labelDisplayUnits;if((u||l)&&this.mySlicer.data){var v=d.createValueFormatter(l,u);this.mySlicer.data.forEach(function(e){(e.valueSegments||[]).forEach(function(e){e.displayValue=v.format(e.value)})});this.mySlicer.refresh()}if(this.isReloadRequired(i,a)){this.data=this.convertData(n,this.state);this.mySlicer.data=this.data.items;this.mySlicer.selectedItems=this.state.selectedItems.map(f.createItemFromSerializedItem)}this.mySlicer.scrollPosition=i.scrollPosition}}}finally{this.isHandlingUpdate=false}};t.prototype.enumerateObjectInstances=function(t){var r=e.prototype.enumerateObjectInstances.call(this,t)||[];var n=this.state.buildEnumerationObjects(t.objectName,this.dataView,false);return r.concat(n)};t.prototype.destroy=function(){e.prototype.destroy.call(this);if(this.mySlicer){this.mySlicer.destroy()}};t.prototype.getCss=function(){return e.prototype.getCss.call(this).concat([v+""])};t.prototype.loadDataFromVisualUpdate=function(e,t,r,n){if(r){if(this.shouldLoadDataIntoSlicer(e,n,t)){var i=this.convertData(r,n);h("Loading data from PBI");this.data=i||{items:[],segmentInfo:[]};var s=this.data.items.slice(0);if(this.loadDeferred&&this.mySlicer.data&&!this.loadDeferred["search"]){this.loadDeferred.resolve(s.slice(this.mySlicer.data.length));delete this.loadDeferred;o.computeRenderedValues(this.mySlicer.data);this.mySlicer.refresh()}else{this.mySlicer.data=s;this.mySlicer.selectedItems=(n.selectedItems||[]).map(f.createItemFromSerializedItem);delete this.loadDeferred}var l=[];a.forOwn(u(r,"categorical.categories"),function(e,t){l.push(e.source.queryName)});if(this.currentCategory&&!a.isEqual(this.currentCategory,l)){if(!a.isEqual(n.selectedItems,[])){h("Clearing Selection, Categories Changed");n.selectedItems=[];this._onSelectionChangedDebounced([])}if(n.searchText!==""){h("Clearing Search, Categories Changed");n.searchText="";this.onSearchPerformed("")}}this.currentCategory=l}}else{this.mySlicer.data=[];n.selectedItems=[]}};t.prototype.convertData=function(e,t){var r=t.labelDisplayUnits,n=t.labelPrecision;var i;if(r||n){i=d.createValueFormatter(r,n)}if(t.hideEmptyItems){this.zeroEmptyItems(e)}var o=f.default(e,i,undefined,t.colors);if(t.hideEmptyItems){o.items=o.items.filter(function(e){return e.match&&e.match.trim()!==""})}return o};t.prototype.zeroEmptyItems=function(e){var t=e.categorical.categories[0].values;for(var r in t){if(!t[r]||t[r].toString().trim().length===0){for(var n=0,i=e.categorical.values;n<i.length;n++){var o=i[n];if(o.values&&o.values[r]){o.values[r]=0}}}}};t.prototype.onSelectionChanged=function(e){if(!this.isHandlingUpdate){this._onSelectionChangedDebounced(e)}};t.prototype.onSearchPerformed=function(e){var t=e&&e.length?'Search for "'+e+'"':"Clear Search";this.state.searchText=e;this.writeStateToPBI(t)};t.prototype.onCanLoadMoreData=function(e,t){return e.result=!!this.dataView&&(t||!!this.dataView.metadata.segment)};t.prototype.onLoadMoreData=function(e,t){if(t){var r=o.createPersistObjectBuilder();var n=o.buildContainsFilter(u(this.dataView,"categorical.categories[0].source"),this.mySlicer.searchString);r.persist("general","selfFilter",n);this.propertyPersister.persist(false,r.build());this.loadDeferred=s.Deferred();this.loadDeferred["search"]=true;e.result=this.loadDeferred.promise()}else if(this.dataView.metadata.segment){var i=!!this.loadDeferred;if(this.loadDeferred){this.loadDeferred.reject()}this.loadDeferred=s.Deferred();e.result=this.loadDeferred.promise();if(!i){this.host.loadMoreData();h("Loading more data")}}};t.prototype.shouldLoadDataIntoSlicer=function(e,t,r){var n=(e&o.UpdateType.Data)===o.UpdateType.Data;return n||this.loadDeferred};t.prototype.writeStateToPBI=function(e){var t=this;this.state.scrollPosition=this.mySlicer.scrollPosition;var r=this.state;h("AttributeSlicer loading state into PBI",r);if(r&&this.host){var n=false;var i=r.buildPersistObjects(this.dataView,true);var a=false;var s=o.getSelectionIdsFromSelectors((r.selectedItems||[]).map(function(e){return e.selector}));if(n){var u=this.selectionManager.getSelectionIds()||[];var c=s.filter(function(e){return!u.some(function(t){return t.equals(e)})});var f=u.filter(function(e){return!s.some(function(t){return t.equals(e)})});c.concat(f).forEach(function(e){t.selectionManager.select(e,true)})}else{a=true;var d=void 0;if(s&&s.length){var p=s.map(function(e){return e.getSelector()});d=l.Selector.filterFromSelector(p)}var v=d?"merge":"remove";var g=i[v]=i[v]||[];g.push({objectName:"general",selector:undefined,properties:{filter:d}})}this.propertyPersister.persist(a,i)}};t.prototype.isReloadRequired=function(e,t){return!t.colors.equals(e.colors)||t.hideEmptyItems!==e.hideEmptyItems};return t}(o.VisualBase);m=i([o.receiveDimensions,o.receiveUpdateType({checkHighlights:true,ignoreCategoryOrder:false})],m);t.default=m;(function(e){var t;(function(t){var r;(function(t){var r=function(t){if(t.objects){var r=t.objects;for(var n in r){if(r.hasOwnProperty(n)){var i=r[n].properties;if(i){for(var o in i){if(i.hasOwnProperty(o)){var a=i[o];if(a.type&&a.type.enumeration){a.type.enumeration=e.createEnumType(a.type.enumeration)}}}}}}}return t};t["AttributeSlicer1652434005853"]={name:"AttributeSlicer1652434005853",displayName:"AttributeSlicer",class:"AttributeSlicer",version:"1.1.1",apiVersion:undefined,capabilities:r({dataRoles:[{name:"Category",kind:0,displayName:"Items"},{name:"Values",kind:1,requiredTypes:[{numeric:true},{integer:true}],displayName:"With Values"},{name:"Series",kind:0,displayName:"Segmented By"},{name:"Color",kind:0,displayName:"Colored By"}],dataViewMappings:[{conditions:[{Category:{max:1},Series:{max:0},Color:{max:0}},{Category:{max:1},Series:{max:0},Values:{max:1,min:0},Color:{max:0}},{Category:{max:1},Series:{min:1,max:1},Values:{max:1,min:1},Color:{max:0}},{Category:{max:1},Series:{max:0},Values:{min:0},Color:{max:0}},{Category:{max:1},Series:{max:1},Values:{min:0,max:0},Color:{max:0}}],categorical:{categories:{for:{in:"Category"},dataReductionAlgorithm:{window:{count:500}}},values:{group:{by:"Series",select:[{for:{in:"Values"}}],dataReductionAlgorithm:{top:{count:60}}}},rowCount:{preferred:{min:2},supported:{min:0}}}},{conditions:[{Category:{max:1},Color:{min:1,max:1},Values:{max:1,min:0},Series:{max:0}}],categorical:{categories:{for:{in:"Category"},dataReductionAlgorithm:{window:{count:500}}},values:{group:{by:"Color",select:[{for:{in:"Values"}}],dataReductionAlgorithm:{top:{count:60}}}},rowCount:{preferred:{min:2},supported:{min:0}}}}],sorting:{default:{}},objects:{general:{objectName:"general",displayName:"General",properties:{selfFilter:{displayName:"selfFilter",type:{filter:{selfFilter:true}}},selection:{displayName:"Selection",type:{text:{}}},textSize:{displayName:"Text Size",description:"The size of the text",type:{numeric:true}},itemTextColor:{displayName:"Text Color",description:"Item text color.",type:{fill:{solid:{color:true}}}},leftAlignText:{displayName:"Text Align Left",description:"On to left align item text.",type:{bool:true}},showOptions:{displayName:"Show options",description:"Should the search box and other options be shown.",type:{bool:true}},showSearch:{displayName:"Show Search",description:"Show the search box.",type:{bool:true}},selfFilterEnabled:{type:{operations:{searchEnabled:true}}},filter:{type:{filter:{}},rule:{output:{property:"selected",selector:["Values"]}}}}},display:{objectName:"display",displayName:"Display",properties:{horizontal:{displayName:"Horizontal",description:"Display the attributes horizontally, rather than vertically",type:{bool:true}},valueColumnWidth:{displayName:"Value Width %",description:"The percentage of the width that the value column should take up.",type:{numeric:true}},hideEmptyItems:{displayName:"Hide Empty Items",description:"Hide empty / blank Items.",type:{bool:true}},labelDisplayUnits:{displayName:"Units",description:"The units to use when displaying values.",type:{formatting:{labelDisplayUnits:true}}},labelPrecision:{displayName:"Precision",description:"The precision to use when displaying values.",type:{numeric:true}},displayValueLabels:{displayName:"Always On Values",description:"Display value labels.",type:{bool:true}},overflowValueLabels:{displayName:"Overflow value text",description:"Allow value text to overflow the bar.",type:{bool:true}}}},selection:{objectName:"selection",displayName:"Selection",properties:{singleSelect:{displayName:"Single Select",description:"Only allow for one item to be selected at a time",type:{bool:true}},brushMode:{displayName:"Brush Mode",description:"Allow for the drag selecting of attributes",type:{bool:true}},showSelections:{displayName:"Use Tokens",description:"Will show the selected attributes as tokens",type:{bool:true}}}},dataPoint:{objectName:"dataPoint",displayName:"Data Point",properties:{fill:{displayName:"fill",type:{fill:{solid:{color:true}}}},colorMode:{displayName:"Color Mode",description:"Determines how the individual bars within the time brush are colored",type:{enumeration:[{value:0,displayName:"Gradient"},{value:1,displayName:"Instance"}]}},startColor:{displayName:"Start color",description:"The start color of the gradient",type:{fill:{solid:{color:true}}}},endColor:{displayName:"End color",description:"The end color of the gradient",type:{fill:{solid:{color:true}}}},startValue:{displayName:"Start Value",description:"The value to use as the start value",type:{numeric:true}},endValue:{displayName:"End Value",description:"The value to use as the end value",type:{numeric:true}},reverseOrder:{displayName:"Reverse Order",description:"If enabled, the order of the bars will be reversed",type:{bool:true}}}}}}),create:function(){var t=Object.create(m.prototype);var r=t.init;t.init=function(n){t.init=r;var i={host:{createSelectionManager:function(){return new e.visuals.utility.SelectionManager({hostServices:n.host})},onSelect:n.host.onSelect.bind(n.host),colors:n.style.colorPalette.dataColors.getAllColors(),persistProperties:n.host.persistProperties.bind(n.host),loadMoreData:n.host.loadMoreData.bind(n.host)},element:n.element.get(0),viewport:{width:500,height:500}};m.call(t,false,i);t.update=function(r){r.type=e.extensibility.v100.convertLegacyUpdateType(r);m.prototype.update.call(t,r)}};return t},custom:true};m.__essex_build_info__="1.1.1 1510796797655 [0b7c4e4b6858935eb5f399a515172006]";Object.defineProperty(m.prototype,"__essex_build_info__",{get:function(){return m.__essex_build_info__}});m.prototype.__essex_visual__=true;(function(t){var r="0.0.1";var n="__essex_patcher__";var i=function(t){var r=e.extensibility.visualApiVersions;for(var n=0,i=r.length;n<i;++n){if(r[n].version===t){return r[n]}}return null};var o=function(e){return!!(e.overloads&&e.overloads[n])};var a=function(e){return!!e.__essex_visual__};var s=function(e){var t=e.overloads;e.overloads=function(e,r){if(!a(e)){return t?t(e,r):e}var n={update:function(){var t=Array.prototype.slice.call(arguments);if(n.options){var r=t[0];for(var i in n.options){if(n.options.hasOwnProperty(i)&&!r.hasOwnProperty(i)){r[i]=n.options[i]}}n.options=null}e.update.apply(e,t)},options:null};var i=t?t(n,r):n;return{update:function(t){if(e.update){n.options=t;i.update(t)}}}};e.overloads[n]=r;return e};var u=i(t);if(u&&!o(u)){s(u)}})("")})(r=t.plugins||(t.plugins={}))})(t=e.visuals||(e.visuals={}))})(window["powerbi"]||(window["powerbi"]={}))},function(e,t){e.exports=powerbi},function(e,t){function r(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}e.exports=r},function(e,t,r){var n=r(114);function i(e,t,r){var i=e==null?undefined:n(e,t);return i===undefined?r:i}e.exports=i},function(e,t,r){var n=r(66);var i=typeof self=="object"&&self&&self.Object===Object&&self;var o=n||i||Function("return this")();e.exports=o},function(e,t){function r(e){return e!=null&&typeof e=="object"}e.exports=r},function(e,t){e.exports=_},function(e,t){e.exports=jQuery},function(e,t,r){"use strict";var n=r(52);var i=r(3);var o=r(174);var a=r(11);var s=r(76);t.METADATA_KEY="__settings__";function u(e,t,r,n,i){"use strict";if(r===void 0){r={}}if(n===void 0){n=true}if(i===void 0){i=true}var o=g(e);var s=new e;a(s,r);if(o){Object.keys(o).forEach(function(e){var a=o[e];var l=a.propertyName;var c=r[l];var f;if(a.isChildSettings){f=u(a.childClassType,t,c,n)}else{if(n&&(c||r.hasOwnProperty(l))){f=i&&c===null?undefined:c}else{var d=x(a,t);f=d.adaptedValue}}s[l]=f})}return s}t.parseSettingsFromPBI=u;function l(e,t,r,i){"use strict";if(i===void 0){i=true}if(t){t=u(e,undefined,t);var o=g(e);if(o){var a=n.default();Object.keys(o).forEach(function(e){var n=o[e];if(n.isChildSettings){var s=t[n.propertyName];if(s&&S(n.descriptor)!==false){var u=l(n.childClassType,t[n.propertyName],r,i);a.mergePersistObjects(u)}}else{c(n,t,r,i,a)}});return a.build()}}}t.buildPersistObjects=l;function c(e,t,r,n,i){"use strict";if(n===void 0){n=true}var o=b(t,e,r,n);if(o){var a=m(e),s=a.objName,u=a.propName;var l=o.adaptedValue;l=l&&l.forEach?l:[l];l.forEach(function(e){var t=!!(e&&e.properties);var r=e;i.persist(s,u,e,undefined,r&&r.selector,r&&r.displayName,t)})}}function f(e,t,r,n,i){"use strict";if(i===void 0){i=false}var o=[{selector:null,objectName:r,properties:{}}];if(t){t=u(e,undefined,t);var a=g(e);if(a){Object.keys(a).forEach(function(e){var s=a[e];if(s.isChildSettings){var u=t[s.propertyName];if(u&&w(t,s.descriptor,n)){o=o.concat(f(s.childClassType,u,r,n,i))}}else{var l=m(s).objName;var c=l===r;if(c){d(s,t,n,i,o)}}})}}o=o.filter(function(e){return Object.keys(e.properties).length>0});return o}t.buildEnumerationObjects=f;function d(e,t,r,n,i){"use strict";if(n===void 0){n=false}var a=b(t,e,r,n);if(a){var s=m(e),u=s.objName,l=s.propName;var c=a.adaptedValue;c=c&&c.forEach?c:[c];c.forEach(function(e){var t=!!(e&&e.properties);var r=e;if(t){r=o(r,{objectName:u});if(typeof r.displayName==="undefined"||r.displayName===null){r.displayName="(Blank)"}r.displayName=r.displayName+"";i.push(r)}else{i[0].properties[l]=a.adaptedValue}})}}function p(e){"use strict";var t;if(e){var r=g(e);if(r){t={};Object.keys(r).map(function(e){var n=r[e];var i=n.isChildSettings,s=n.childClassType;if(i){if(S(n.descriptor)!==false){o(t,p(s))}}else{var u=h(n);if(u){var l=u.objectName;var c=t[l]||u;a(c.properties,u.properties);t[l]=c}}})}}return t}t.buildCapabilitiesObjects=p;function h(e){"use strict";var t=m(e),r=t.objName,n=t.propName;var i=e.descriptor,o=i.category,a=i.displayName,s=i.defaultValue,u=i.config,l=i.description,c=i.persist;var f="General";if(c!==false){var d={objectName:r,displayName:o||f,properties:{}};var p=void 0;if(typeof s==="number"){p={numeric:true}}else if(typeof s==="boolean"){p={bool:true}}else if(typeof s==="string"){p={text:{}}}u=u||{};var h={displayName:u.displayName||a||n,description:u.description||l,type:u.type||p};if(u.rule){h.rule=u.rule}d.properties[n]=h;return d}}function v(e,t){"use strict";var r=JSON.parse(s(t,function(e,t){return t===undefined?null:t}));return r}t.toJSON=v;function g(e){"use strict";var r;if(e){r=i(e,t.METADATA_KEY+".settings");if(!r&&e.constructor){r=i(e.constructor,t.METADATA_KEY+".settings")}}return r}function y(e,t){"use strict";var r=g(e);if(r&&r[t]){return r[t].descriptor}}t.getSetting=y;function m(e){"use strict";var t=e.propertyName,r=e.descriptor,n=r.name,i=r.category;return{objName:_(i||"General"),propName:(n||t).replace(/\s/g,"_")}}t.getPBIObjectNameAndPropertyName=m;function b(e,t,r,n){"use strict";if(n===void 0){n=false}var i=t.descriptor,o=t.propertyName;var a=i.compose;var s=w(e,i,r);var u=S(i);if((n||s)&&u!==false){var l=e[o];if(a){l=a(l,i,r,t)}return{adaptedValue:l}}}t.convertValueToPBI=b;function x(e,t){"use strict";var r=i(t,"metadata.objects");var n=e.descriptor,o=e.descriptor,a=o.defaultValue,s=o.parse,u=o.min,l=o.max;var c=m(e),f=c.objName,d=c.propName;var p=i(r,f+"."+d);var h=typeof a!=="undefined"||n.hasOwnProperty("defaultValue");p=s?s(p,n,t,e):p;if(h&&(p===null||typeof p==="undefined")){p=a}if(typeof u!=="undefined"){p=Math.max(u,p)}if(typeof l!=="undefined"){p=Math.min(l,p)}return{adaptedValue:p}}t.convertValueFromPBI=x;function _(e){"use strict";return e.replace(/(?:^\w|[A-Z]|\b\w)/g,function(e,t){return t===0?e.toLowerCase():e.toUpperCase()}).replace(/\s+/g,"")}function w(e,t,r){"use strict";var n=t.hidden,i=t.enumerable;if(typeof i!=="undefined"){return!!(typeof i==="function"?i(e,r):i)}return!(typeof n==="function"?n(e,r):n)}function S(e){"use strict";return e.persist}function C(e,t,r,n){"use strict";var i=m(e),o=i.objName,a=i.propName;return{objectName:o,selector:t,displayName:r,properties:(s={},s[a]=n,s)};var s}t.composeInstance=C;function A(e,t,r){"use strict";var n=m(t),o=n.objName,a=n.propName;var s=i(e,"objects."+o);if(r){return i(s,"$instances."+r+"."+a)}else{return i(s,""+a)}}t.getObjectsForColumn=A;function O(e,t){"use strict";return{metadata:e.queryName,id:t}}t.createObjectSelectorForColumn=O},function(e,t,r){"use strict";var n=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};r(1);var i=r(8);var o=r(11);function a(e){"use strict";return function(t,r){var n={propertyName:r,descriptor:e,isChildSettings:false,classType:t};if(Object.freeze){n=Object.freeze(n)}d(t,r,n);Object.defineProperty(t,r,{writable:true,enumerable:true});return t}}t.setting=a;function s(e,t){"use strict";return function(r,i){var o=e;var a=function(e){n(t,e);function t(){return e.apply(this,arguments)||this}return t}(o);var s=c(o);t=t||{};var u={propertyName:i,descriptor:t,isChildSettings:true,childClassType:a,classType:r};c(a,Object.create(s));l(u);if(!e){throw new Error("Could not find config for setting: "+i)}if(Object.freeze){u=Object.freeze(u)}d(r,i,u);Object.defineProperty(r,i,{writable:true,enumerable:true});return r}}t.settings=s;function u(e,t){"use strict";var r=Object.create(o({},t),{descriptor:{value:Object.create({category:e.descriptor.category},Object.keys(t.descriptor).reduce(function(e,r){e[r]={enumerable:true,value:t.descriptor[r]};return e},{}))}});r.parentSetting=e;r.classType=e.childClassType;l(r);return r}function l(e){"use strict";if(e.isChildSettings){var t=c(e.childClassType);t.settings=Object.keys(t.settings).reduce(function(r,n){r[n]=u(e,t.settings[n]);return r},{})}}function c(e,t){"use strict";var r=e.constructor===Function?e:e.constructor;return r[i.METADATA_KEY]=t||r[i.METADATA_KEY]||{}}function f(e){"use strict";var t=c(e);return t.settings=t.settings||{}}function d(e,t,r){"use strict";f(e)[t]=r}t.defineSetting=d},function(e,t,r){var n=r(27),i=r(133),o=r(158);var a="[object Null]",s="[object Undefined]";var u=n?n.toStringTag:undefined;function l(e){if(e==null){return e===undefined?s:a}e=Object(e);return u&&u in e?i(e):o(e)}e.exports=l},function(e,t,r){var n=r(63),i=r(64),o=r(34);var a=i(function(e,t){n(t,o(t),e)});e.exports=a},function(e,t){var r=Array.isArray;e.exports=r},function(e,t){"use strict";var r=["#01B8AA","#FD625E","#F2C80F","#8AD4EB","#FE9666","#A66999","#3599B8","#DFBFBF"];r.primary=r.slice(0);r.full=["#01B8AA","#FD625E","#F2C80F","#8AD4EB","#FE9666","#A66999","#3599B8","#DFBFBF","#4AC5BB","#5F6B6D","#FB8281","#F4D25A","#7F898A","#A4DDEE","#FDAB89","#B687AC","#28738A","#A78F8F","#168980","#293537","#BB4A4A","#B59525","#475052","#6A9FB0","#BD7150","#7B4F71","#1B4D5C","#706060","#0F5C55","#1C2325","#7D3231","#796419","#303637","#476A75","#7E4B36","#52354C","#0D262E","#544848"];Object.defineProperty(t,"__esModule",{value:true});t.default=r;t.fullColors=r.full},function(e,t,r){var n=r(145),i=r(146),o=r(147),a=r(148),s=r(149);function u(e){var t=-1,r=e==null?0:e.length;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n;u.prototype["delete"]=i;u.prototype.get=o;u.prototype.has=a;u.prototype.set=s;e.exports=u},function(e,t,r){var n=r(18);function i(e,t){var r=e.length;while(r--){if(n(e[r][0],t)){return r}}return-1}e.exports=i},function(e,t,r){var n=r(143);function i(e,t){var r=e.__data__;return n(t)?r[typeof t=="string"?"string":"hash"]:r.map}e.exports=i},function(e,t,r){var n=r(29);var i=n(Object,"create");e.exports=i},function(e,t){function r(e,t){return e===t||e!==e&&t!==t}e.exports=r},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}n(r(50));n(r(91));var i=r(87);t.VisualBase=i.default;var o=r(39);t.CatchingVisualBase=o.CatchingVisualBase;var a=r(13);t.colors=a.default},function(e,t,r){"use strict";var n=r(8);var i=r(11);var o=function(){function e(){}e.create=function(e){return n.parseSettingsFromPBI(this,undefined,e,true)};e.createFromPBI=function(e,t){return n.parseSettingsFromPBI(this,e,t,false)};e.buildCapabilitiesObjects=function(){return n.buildCapabilitiesObjects(this)};e.prototype.receive=function(e){return this.constructor.create(i(this.toJSONObject(),e))};e.prototype.receiveFromPBI=function(e){return this.constructor.createFromPBI(e,this.toJSONObject())};e.prototype.buildEnumerationObjects=function(e,t,r){if(r===void 0){r=false}return n.buildEnumerationObjects(this.constructor,this,e,t,r)};e.prototype.buildPersistObjects=function(e,t){if(t===void 0){t=false}return n.buildPersistObjects(this.constructor,this,e,t)};e.prototype.toJSONObject=function(){return n.toJSON(this.constructor,this)};return e}();t.HasSettings=o},function(e,t,r){"use strict";var n=r(9);var i=r(44);var o=r(41);function a(e){"use strict";return d({text:{}},e)}t.textSetting=a;function s(e){"use strict";return d({bool:true},e)}t.boolSetting=s;function u(e){"use strict";return d({numeric:true},e)}t.numberSetting=u;function l(e){"use strict";e=_.merge({},{config:{type:powerbi.visuals.StandardObjectProperties.fill.type},compose:o.colorComposer(e?e.defaultValue:"#ccc"),parse:i.colorParser(e?e.defaultValue:"#ccc")},e);return n.setting(e)}t.colorSetting=l;function c(e){"use strict";e=_.merge({},{config:{type:powerbi.visuals.StandardObjectProperties.fill.type},compose:o.coloredObjectInstanceComposer(e?e.defaultValue:"#ccc"),parse:i.colorCategoricalInstanceObjectParser(e?e.defaultValue:"#ccc")},e);return n.setting(e)}t.instanceColorSetting=c;function f(e,t){"use strict";return d({enumeration:{members:function(t){var r=Object.keys(e).map(function(t){return e[t]});var n=r.filter(function(e){return typeof e==="string"});return n.map(function(t){return{value:e[t],displayName:t}})}}},t)}t.enumSetting=f;function d(e,t){"use strict";t=_.merge({},{config:{type:e}},t);return n.setting(t)}},function(e,t){"use strict";var r;(function(e){e[e["Unknown"]=0]="Unknown";e[e["Data"]=1]="Data";e[e["Resize"]=2]="Resize";e[e["Settings"]=4]="Settings";e[e["Initial"]=8]="Initial";e[e["DataAndResize"]=3]="DataAndResize";e[e["DataAndSettings"]=5]="DataAndSettings";e[e["SettingsAndResize"]=6]="SettingsAndResize";e[e["All"]=7]="All"})(r||(r={}));Object.defineProperty(t,"__esModule",{value:true});t.default=r},function(e,t,r){"use strict";r(1);var n=r(22);var i=r(11);t.DEFAULT_CALCULATE_SETTINGS={checkHighlights:false,defaultUnkownToData:false,ignoreCategoryOrder:true};Object.freeze(t.DEFAULT_CALCULATE_SETTINGS);function o(e,r,o){"use strict";var l=n.default.Unknown;var c=i({},t.DEFAULT_CALCULATE_SETTINGS,typeof o==="boolean"?{defaultUnkownToData:o}:o||{});if(u(e,r,c)){l^=n.default.Resize}if(a(e,r,c)){l^=n.default.Data}if(s(e,r,c)){l^=n.default.Settings}if(!e){l^=n.default.Initial}if(c.defaultUnkownToData&&l===n.default.Unknown){l=n.default.Data}return l}Object.defineProperty(t,"__esModule",{value:true});t.default=o;function a(e,t,r){"use strict";var n=e&&e.dataViews||[];var i=t.dataViews||[];if(n.length!==i.length){i.forEach(function(e){return l(e)});return true}for(var o=0;o<n.length;o++){if(p(n[o],i[o],r)){i.forEach(function(e){return l(e)});return true}}i.forEach(function(e){return l(e)});return false}function s(e,t,r){"use strict";var n=e&&e.dataViews||[];var i=t.dataViews||[];if(n.length!==i.length){return true}for(var o=0;o<n.length;o++){var a=n[o].metadata||{};var s=i[o].metadata||{};if(!_.isEqual(a.objects,s.objects)){return true}}}function u(e,t,r){"use strict";return!e||t.resizeMode}function l(e){"use strict";if(e){var t=e.categorical&&e.categorical.categories||[];t.forEach(function(e){if(e.identity){e.identity["$prevLength"]=e.identity.length}})}}var c=["queryName","roles","sort","aggregates"];function f(e,t,r){"use strict";if(e===t){return false}else if(!e||!t){return true}if(e.length!==t.length){return true}if(e.length>0){var n=e.length-1;return!r(e[0],t[0])||!r(e[n],t[n])||_.some(e,function(e,n){return!r(e,t[n])})}return false}function d(e,t){"use strict";var r=f(e.identity,t.identity,function(e,t){return e.key===t.key});if(e.identity&&t.identity&&e.identity===t.identity){var n=e.identity["$prevLength"];var i=e.identity.length;e.identity["$prevLength"]=i;return n!==i}return r}function p(e,t,r){"use strict";var n=e.categorical&&e.categorical.categories||[];var i=t.categorical&&t.categorical.categories||[];var o=e.categorical&&e.categorical.values||[];var a=t.categorical&&t.categorical.values||[];var s=e.metadata&&e.metadata.columns||[];var u=t.metadata&&t.metadata.columns||[];if(n.length!==i.length||s.length!==u.length||o.length!==a.length){return true}if(r.ignoreCategoryOrder){s=s.sort(function(e,t){return e.queryName.localeCompare(t.queryName)});u=u.sort(function(e,t){return e.queryName.localeCompare(t.queryName)})}for(var l=0;l<s.length;l++){if(!_.isEqual(_.pick(s[l],c),_.pick(u[l],c))){return true}}for(var l=0;l<n.length;l++){if(d(n[l],i[l])){return true}}if(r.checkHighlights){for(var l=0;l<o.length;l++){if(h(o[l],a[l])){return true}}}return false}function h(e,t){"use strict";if(e&&t){var r=e.highlights||[];var n=t.highlights||[];if(r===n){var i=r["$prevLength"];var o=r.length;r["$prevLength"]=o;return i!==o}if(r.length!==n.length){return true}return r.some(function(e,t){return e!==n[t]})}return false}},function(e,t,r){"use strict";r(1);var n;(function(e){e[e["Gradient"]=0]="Gradient";e[e["Instance"]=1]="Instance"})(n=t.ColorMode||(t.ColorMode={}))},function(e,t,r){"use strict";var n=r(3);function i(e){"use strict";var t=n(powerbi,"data.services.SemanticQuerySerializer",{serializeExpr:JSON.stringify});return{serializedExpr:t.serializeExpr(e)}}t.serializeExpr=i},function(e,t,r){"use strict";var n=r(3);var i=/return\s+([^\;\}]+)/;function o(e,t,r){"use strict";var o=i.exec(t.toString())[1];return n(e,o.split(".").slice(1).join("."),r)}Object.defineProperty(t,"__esModule",{value:true});t.default=o},function(e,t,r){var n=r(4);var i=n.Symbol;e.exports=i},function(e,t,r){var n=r(65);function i(e,t,r){if(t=="__proto__"&&n){n(e,t,{configurable:true,enumerable:true,value:r,writable:true})}else{e[t]=r}}e.exports=i},function(e,t,r){var n=r(116),i=r(134);function o(e,t){var r=i(e,t);return n(r)?r:undefined}e.exports=o},function(e,t){var r=9007199254740991;var n=/^(?:0|[1-9]\d*)$/;function i(e,t){t=t==null?r:t;return!!t&&(typeof e=="number"||n.test(e))&&(e>-1&&e%1==0&&e<t)}e.exports=i},function(e,t,r){var n=r(32),i=r(73);function o(e){return e!=null&&i(e.length)&&!n(e)}e.exports=o},function(e,t,r){var n=r(10),i=r(2);var o="[object AsyncFunction]",a="[object Function]",s="[object GeneratorFunction]",u="[object Proxy]";function l(e){if(!i(e)){return false}var t=n(e);return t==a||t==s||t==o||t==u}e.exports=l},function(e,t,r){var n=r(10),i=r(5);var o="[object Symbol]";function a(e){return typeof e=="symbol"||i(e)&&n(e)==o}e.exports=a},function(e,t,r){var n=r(110),i=r(118),o=r(31);function a(e){return o(e)?n(e,true):i(e)}e.exports=a},function(e,t,r){(function(n){t=e.exports=r(181);t.log=a;t.formatArgs=o;t.save=s;t.load=u;t.useColors=i;t.storage="undefined"!=typeof window.chrome&&"undefined"!=typeof window.chrome.storage?window.chrome.storage.local:l();t.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"];function i(){if(typeof window!=="undefined"&&"process"in window&&window.process.type==="renderer"){return true}return typeof document!=="undefined"&&"WebkitAppearance"in document.documentElement.style||typeof window!=="undefined"&&window.console&&(console.firebug||console.exception&&console.table)||navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)}t.formatters.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}};function o(e){var r=this.useColors;e[0]=(r?"%c":"")+this.namespace+(r?" %c":" ")+e[0]+(r?"%c ":" ")+"+"+t.humanize(this.diff);if(!r)return;var n="color: "+this.color;e.splice(1,0,n,"color: inherit");var i=0;var o=0;e[0].replace(/%[a-z%]/g,function(e){if("%%"===e)return;i++;if("%c"===e){o=i}});e.splice(o,0,n)}function a(){return"object"===typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function s(e){try{if(null==e){t.storage.removeItem("debug")}else{t.storage.debug=e}}catch(e){}}function u(){try{return t.storage.debug}catch(e){}if(typeof n!=="undefined"&&"env"in n){
return""}}t.enable(u());function l(){try{return window.localStorage}catch(e){}}}).call(t,r(36))},function(e,t){var r=e.exports={};var n;var i;function o(){throw new Error("setTimeout has not been defined")}function a(){throw new Error("clearTimeout has not been defined")}(function(){try{if(typeof setTimeout==="function"){n=setTimeout}else{n=o}}catch(e){n=o}try{if(typeof clearTimeout==="function"){i=clearTimeout}else{i=a}}catch(e){i=a}})();function s(e){if(n===setTimeout){return setTimeout(e,0)}if((n===o||!n)&&setTimeout){n=setTimeout;return setTimeout(e,0)}try{return n(e,0)}catch(t){try{return n.call(null,e,0)}catch(t){return n.call(this,e,0)}}}function u(e){if(i===clearTimeout){return clearTimeout(e)}if((i===a||!i)&&clearTimeout){i=clearTimeout;return clearTimeout(e)}try{return i(e)}catch(t){try{return i.call(null,e)}catch(t){return i.call(this,e)}}}var l=[];var c=false;var f;var d=-1;function p(){if(!c||!f){return}c=false;if(f.length){l=f.concat(l)}else{d=-1}if(l.length){h()}}function h(){if(c){return}var e=s(p);c=true;var t=l.length;while(t){f=l;l=[];while(++d<t){if(f){f[d].run()}}d=-1;t=l.length}f=null;c=false;u(e)}r.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1){for(var r=1;r<arguments.length;r++){t[r-1]=arguments[r]}}l.push(new v(e,t));if(l.length===1&&!c){s(h)}};function v(e,t){this.fun=e;this.array=t}v.prototype.run=function(){this.fun.apply(null,this.array)};r.title="browser";r.browser=true;r.env={};r.argv=[];r.version="";r.versions={};function g(){}r.on=g;r.addListener=g;r.once=g;r.off=g;r.removeListener=g;r.removeAllListeners=g;r.emit=g;r.binding=function(e){throw new Error("process.binding is not supported")};r.cwd=function(){return"/"};r.chdir=function(e){throw new Error("process.chdir is not supported")};r.umask=function(){return 0}},function(e,t){e.exports=function(e){if(!e.webpackPolyfill){e.deprecate=function(){};e.paths=[];e.children=[];e.webpackPolyfill=1}return e}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:true});var n=r(6);function i(e){"use strict";if(e&&e.toISOString){var t=e;return t.getMonth()+1+"/"+t.getDate()+"/"+t.getFullYear()+" "+t.getHours()+":"+t.getMinutes()+(t.getHours()>=12?"PM":"AM")}return e===null||e===undefined?"":e+""}t.prettyPrintValue=i;function o(e,t,r,n,i){"use strict";if(i===void 0){i=""}return{id:r,match:e,color:i,value:t||0,renderedValue:n,equals:function(e){return r===e.id}}}t.createItem=o;var a=["selectedItems","searchText"];function s(e,t){"use strict";var r=e&&e["toJSONObject"]?e["toJSONObject"]():e;var i=t&&t["toJSONObject"]?t["toJSONObject"]():t;return n.isEqual(r&&r.searchText,i&&i.searchText)&&n.isEqual(n.omit(r,a),n.omit(i,a))&&u(r&&r.selectedItems,i&&i.selectedItems)}t.isStateEqual=s;function u(e,t){"use strict";if(e===t){return true}if(e&&t&&e.length===t.length){return e.filter(function(e,r){return e.id!==t[r].id}).length===0}return false}},function(e,t,r){"use strict";r(1);var n=function(){function e(e,t){if(t===void 0){t=false}this.visualName=e;this.throwErrors=t}e.prototype.init=function(e){try{this.doInit(e)}catch(e){console.log("%s::init error",this.visualName,e);this.rethrow(e)}};e.prototype.destroy=function(){try{this.doDestroy()}catch(e){console.log("%s::destroy error",this.visualName,e);this.rethrow(e)}};e.prototype.doDestroy=function(){};e.prototype.update=function(e){try{this.doUpdate(e)}catch(e){console.log("%s:update error",this.visualName,e);this.rethrow(e)}};e.prototype.doUpdate=function(e){};e.prototype.onResizing=function(e,t){try{this.doOnResizing(e,t)}catch(e){console.log("%s:onResizing error",this.visualName,e);this.rethrow(e)}};e.prototype.doOnResizing=function(e,t){};e.prototype.onDataChanged=function(e){try{this.handleOnDataChanged(e)}catch(e){console.log("%s:onDataChanged error",this.visualName,e);this.rethrow(e)}};e.prototype.handleOnDataChanged=function(e){};e.prototype.onViewModeChanged=function(e){try{this.handleOnViewModeChanged(e)}catch(e){console.log("%s:onDataChanged error",this.visualName,e);this.rethrow(e)}};e.prototype.handleOnViewModeChanged=function(e){};e.prototype.onClearSelection=function(){try{this.handleOnClearSelection()}catch(e){console.log("%s:onClearSelection error",this.visualName,e);this.rethrow(e)}};e.prototype.handleOnClearSelection=function(){};e.prototype.canResizeTo=function(e){try{return this.handleCanResizeTo(e)}catch(e){console.log("%s:onResizeTo error",this.visualName,e);this.rethrow(e)}};e.prototype.handleCanResizeTo=function(e){return true};e.prototype.enumerateObjectInstances=function(e){try{return this.handleEnumerateObjectInstances(e)}catch(e){console.log("%s:enumerateObjectInstances error",e);this.rethrow(e)}};e.prototype.handleEnumerateObjectInstances=function(e){return undefined};e.prototype.enumerateObjectRepetition=function(){try{return this.handleEnumerateObjectRepetition()}catch(e){console.log("%s:enumerateObjectRepetition error",e);this.rethrow(e)}};e.prototype.handleEnumerateObjectRepetition=function(){return undefined};e.prototype.rethrow=function(e){if(this.throwErrors){throw e}};return e}();t.CatchingVisualBase=n},function(e,t,r){"use strict";var n=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};var i=this&&this.__decorate||function(e,t,r,n){var i=arguments.length,o=i<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,r):n,a;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")o=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)if(a=e[s])o=(i<3?a(o):i>3?a(t,r,o):a(t,r))||o;return i>3&&o&&Object.defineProperty(t,r,o),o};var o=r(24);var a=r(48);var s=r(21);var u=r(9);var l=r(20);var c=r(43);var f=r(13);var d=function(e){n(t,e);function t(){return e.apply(this,arguments)||this}t.prototype.equals=function(e){if(e){var t=e.gradient||undefined;var r=this.gradient||undefined;if(r&&!t||t&&!r){return false}var n=e.instanceColors||[];var i=this.instanceColors||[];if(n.length!==i.length){return false}var o=i.some(function(e,t){var r=n[t];return r.name!==e.name||r.color!==e.color});return!o&&(r===t||r.equals(t))&&this.reverseOrder===e.reverseOrder&&this.colorMode===e.colorMode}return false};return t}(l.HasSettings);i([s.instanceColorSetting({name:"fill",defaultValue:function(e){return f.fullColors[e]||"#ccc"},enumerable:function(e,t){return a.dataSupportsColorizedInstances(t)&&!(e.colorMode===o.ColorMode.Gradient)}})],d.prototype,"instanceColors",void 0);i([s.enumSetting(o.ColorMode,{displayName:"Color Mode",defaultValue:o.ColorMode.Instance,description:"Determines how the individual bars within the time brush are colored"})],d.prototype,"colorMode",void 0);i([c.gradientSetting({enumerable:function(e,t){return a.dataSupportsGradients(t)&&e.colorMode===o.ColorMode.Gradient}})],d.prototype,"gradient",void 0);i([u.setting({displayName:"Reverse Order",description:"If enabled, the order of the bars will be reversed",defaultValue:false,hidden:function(e,t){return!a.dataSupportsValueSegments(t)}})],d.prototype,"reverseOrder",void 0);t.ColoredObjectsSettings=d},function(e,t,r){"use strict";var n=r(8);var i=r(175);function o(e){"use strict";if(e===void 0){e="#ccc"}return function(t,r,i,o,a){if(t){var s=n.getPBIObjectNameAndPropertyName(o).propName;return(t.forEach?t:[t]).map(function(t,r){var n=typeof e==="function"?e(r,i,t.identity):e;var o=t.color||n;return{displayName:t.name,selector:t.identity?powerbi.visuals.ColorHelper.normalizeSelector(powerbi.visuals.SelectionId.createWithId(t.identity).getSelector(),false):undefined,properties:(a={},a[s]=o,a)};var a})}}}t.coloredObjectInstanceComposer=o;function a(e,t){"use strict";return function(r,n,o,a){t=typeof t==="function"?t():t;if(r){if(e){var s={};i(s,e,r||t);return s}return r||t}}}t.basicObjectComposer=a;function s(e){"use strict";if(e===void 0){e="#ccc"}return a(undefined,e)}t.colorComposer=s},function(e,t,r){"use strict";var n=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};var i=this&&this.__decorate||function(e,t,r,n){var i=arguments.length,o=i<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,r):n,a;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")o=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)if(a=e[s])o=(i<3?a(o):i>3?a(t,r,o):a(t,r))||o;return i>3&&o&&Object.defineProperty(t,r,o),o};var o=r(21);var a=r(20);var s=function(e){n(t,e);function t(){return e.apply(this,arguments)||this}t.prototype.equals=function(e){if(e){return(this.startColor||undefined)===(e.startColor||undefined)&&(this.endColor||undefined)===(e.endColor||undefined)&&(this.endValue||undefined)===(e.endValue||undefined)&&(this.startValue||undefined)===(e.startValue||undefined)}return false};return t}(a.HasSettings);i([o.colorSetting({displayName:"Start color",description:"The start color of the gradient",defaultValue:"#bac2ff"})],s.prototype,"startColor",void 0);i([o.colorSetting({displayName:"End color",description:"The end color of the gradient",defaultValue:"#0229bf"})],s.prototype,"endColor",void 0);i([o.numberSetting({displayName:"Start Value",description:"The value to use as the start value"})],s.prototype,"startValue",void 0);i([o.numberSetting({displayName:"End Value",description:"The value to use as the end value"})],s.prototype,"endValue",void 0);t.GradientSettings=s},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}n(r(42));n(r(90))},function(e,t,r){"use strict";var n=r(26);var i=r(8);var o=r(3);function a(e){"use strict";if(e===void 0){e="#ccc"}return s(e,function(e){var t=n.default(e,function(e){return e.categorical.values},[]);return t&&t.grouped&&t.grouped()||[]})}t.colorCategoricalInstanceObjectParser=a;function s(e,t){"use strict";if(e===void 0){e="#ccc"}return function(r,o,a,s){var u=t(a);var l=i.getPBIObjectNameAndPropertyName(s),c=l.objName,f=l.propName;if(u&&u.forEach){return u.map(function(t,r){var i=t.objects;var o=i&&i[c];var a=o&&o[f];var s=typeof e==="function"?e(r):e;return{name:t.name,color:n.default(a,function(e){return e.solid.color},s),identity:t.identity}})}}}t.coloredInstanceObjectParser=s;function u(e,t){"use strict";return function(r){var n=o(r,e);if((typeof n==="undefined"||n===null)&&t){n=typeof t==="function"?t():t}return n}}t.basicParser=u;function l(e){"use strict";return u("solid.color",e)}t.colorParser=l},function(e,t,r){"use strict";r(1);var n=function(){function e(e,t){if(t===void 0){t=100}var r=this;this.host=e;this.delay=t;this.propsToUpdate=[];this.propUpdater=_.debounce(function(){if(r.propsToUpdate&&r.propsToUpdate.length){var e=r.propsToUpdate.slice(0);r.propsToUpdate.length=0;var t={};var n;e.forEach(function(e){e.changes.forEach(function(e){Object.keys(e).forEach(function(r){if(!t[r]){t[r]=[]}(n=t[r]).push.apply(n,e[r]);var n})});if(e.selection){n=true}});if(n){r.host.onSelect({data:[]})}r.host.persistProperties(t)}},this.delay)}e.prototype.persist=function(e){var t=[];for(var r=1;r<arguments.length;r++){t[r-1]=arguments[r]}this.propsToUpdate.push({changes:t,selection:e});this.propUpdater()};return e}();Object.defineProperty(t,"__esModule",{value:true});t.default=n},function(e,t,r){"use strict";var n=r(86);var i=r(6);var o=r(13);r(1);function a(e,t,r,a){"use strict";var s=[];if(e&&e.length){var u=!!(e.source&&e.source.roles["Series"]);s=u?e.grouped():e.map(function(e,t){return{name:t+1+"",identity:e.identity}})}var l;if(r){var c=r.startValue,f=r.endValue,d=r.startColor,p=r.endColor;var h=typeof c!=="undefined"?c:n.min(s.map(function(e){return e.name}));var v=typeof f!=="undefined"?f:n.max(s.map(function(e){return e.name}));l=n.scale.linear().domain([isNaN(h)?0:h,isNaN(v)?s.length-1:v]).interpolate(n.interpolateRgb).range([d,p])}return i.sortBy(s,["name"]).map(function(e,r){var n=o.fullColors[r];if(a&&a[r]){n=a[r].color}else if(l){n=l(isNaN(e.name)?r:e.name)}else{n=t||o.fullColors[r]}n=n||"#ccc";return{name:e.name,identity:e.identity,color:n}})}Object.defineProperty(t,"__esModule",{value:true});t.default=a},function(e,t){"use strict";function r(){"use strict";var e=[];for(var t=0;t<arguments.length;t++){e[t]=arguments[t]}var r;if(e&&e.length>1){r="<span>"+e[0]+"</span>";for(var n=1;n<e.length;n++){var i=e[n];var o=r.indexOf("%c");if(o>=0){var a=r.substring(0,o);r=a+'</span><span style="'+i+'">'+r.substring(o+2)}else{r+=i}}}else{r=e.join("")}return r}Object.defineProperty(t,"__esModule",{value:true});t.default=r},function(e,t,r){"use strict";var n=r(26);var i=r(13);var o=powerbi.visuals.SelectionId;var a=r(46);var s=r(24);var u=r(3);function l(e,t,r){"use strict";var u;var l=n.default(e,function(e){return e.categorical.categories});var f=n.default(e,function(e){return e.categorical.categories[0].values});var d=n.default(e,function(e){return e.categorical.categories[0].identity});var y=n.default(e,function(e){return e.categorical.values});if(f){r=r||{};var m=r.colorMode===s.ColorMode.Gradient;var b=h(e)&&m;var x=p(e)?i.fullColors[0]:undefined;var _=v(e)&&!m;var w=a.default(y,x,b?r.gradient:undefined,_?r.instanceColors:undefined);u=f.map(function(e,n){var i=o&&o.createWithId?o.createWithId(d[n]):n;var a=0;var s;if(y){var u=g(y,w,n);s=u.segments;a=u.total;if(r&&r.reverseOrder){s.reverse()}}var c=t(l,n,a,i,s);c.valueSegments=s;return c});c(u);return{items:u,segmentInfo:w}}}t.convertItemsWithSegments=l;function c(e){"use strict";if(e&&e.length){var t=f(e);var r=0;e.forEach(function(e){var n=e.valueSegments||[];var i=0;n.forEach(function(e,r){e.width=Math.abs(e.value)/t.max/n.length*100;i+=e.width});if(i>r){r=i}});if(r>0){e.forEach(function(e){e.renderedValue=100*(100/r)})}}}t.computeRenderedValues=c;function f(e){"use strict";var t=0;if(e&&e.length){e.forEach(function(e){(e.valueSegments||[]).forEach(function(e,r){var n=e.value;if(typeof n==="number"){var i=Math.abs(n);if(i>t){t=i}}})})}return{min:0,max:t}}function d(e){"use strict";return u(e,"categorical.values.length",0)>0}t.dataSupportsValueSegments=d;function p(e){"use strict";if(d(e)){return n.default(e,function(e){return e.categorical.values.length},0)===1}return false}t.dataSupportsDefaultColor=p;function h(e){"use strict";if(d(e)){return n.default(e,function(e){return e.categorical.values.length},0)>0}return false}t.dataSupportsGradients=h;function v(e){"use strict";if(d(e)&&e.categorical.values.grouped){var t=e.categorical.values.grouped();return t.filter(function(e){return!!e.identity}).length>0}return false}t.dataSupportsColorizedInstances=v;function g(e,t,r){"use strict";var n=0;var i=t.map(function(t,i){var o=e[i].highlights||[];var a=o[r];var s=e[i].values[r];if(typeof s==="number"){n+=s}var u=t.color,l=t.name;var c={name:l,color:u,value:s,displayValue:s,width:0};if(o&&o.length){var f=0;if(s&&typeof s==="number"&&a){f=a/s*100}c.highlightWidth=f}return c});return{segments:i,total:n}}},function(e,t,r){"use strict";r(1);var n=r(56);function i(e){"use strict";return(e||[]).map(function(e){var t=o(e);return powerbi.visuals.SelectionId.createWithId(powerbi.data.createDataViewScopeIdentity(t))})}t.getSelectionIdsFromSelectors=i;function o(e){"use strict";var t=e.data[0];if(t){var r=t.expr||t["_expr"];if(t.serializedExpr){return n.deserializeExpr(t)}else if(r&&(!r.constructor||r.constructor===Object)){var i=r.left;var o=i.source;var a=r.right;if(a.type){var s=new powerbi.ValueType(a.type["underlyingType"],a.type["category"]);var u=new powerbi.data.SQConstantExpr(s,a.value,a.valueEncoded);var l=new powerbi.data.SQEntityExpr(o.schema,o.entity,o.variable);var c=new powerbi.data.SQColumnRefExpr(l,i.ref);var f=new powerbi.data.SQCompareExpr(r.comparison,c,u);return f}}return r}}},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}var i=r(35);i.save=function(){};if(false){i.enable(process.env.DEBUG)}var o=r(23);t.calcUpdateType=o.default;n(r(94));var a=r(47);t.colorizedLog=a.default;var s=r(95);t.createPropertyPersister=s.default;var u=r(96);t.elementLogWriter=u.default;var l=r(97);t.hasDataChanged=l.default;var c=r(98);t.listDiff=c.default;n(r(51));var f=r(45);t.PropertyPersister=f.default;n(r(53));n(r(101));var d=r(22);t.UpdateType=d.default;var p=r(105);t.updateTypeGetter=p.default;var h=r(92);t.Visual=h.default;var v=r(93);t.buildContainsFilter=v.default;var g=r(100);t.parseSelectionIds=g.default;var y=r(52);t.createPersistObjectBuilder=y.default;n(r(49));var m=r(26);t.get=m.default;var b=r(46);t.calculateSegments=b.default;n(r(56));n(r(48));n(r(24))},function(e,t,r){"use strict";var n=r(35);var i=[o()];t.logger=function(e){var t=n(e);t.log=function(){var e=[];for(var t=0;t<arguments.length;t++){e[t]=arguments[t]}i.forEach(function(t){t.apply(this,e)})};return t};t.logger.addWriter=function(e){i.push(e)};function o(){"use strict";return function(){var e=[];for(var t=0;t<arguments.length;t++){e[t]=arguments[t]}console.log.apply(console,e)}}t.consoleLogWriter=o},function(e,t,r){"use strict";var n=r(11);function i(){"use strict";var e={};var t={merge:{},remove:{}};var r={persist:function i(o,a,s,u,l,c,f){"use strict";u=u||(typeof s==="undefined"?"remove":"merge");var d=t[u][o];if(f||!d){d={objectName:o,selector:l,properties:{}};if(!f){t[u][o]=d}e[u]=e[u]||[];e[u].push(d);if(c){d["displayName"]=c}}if(s&&s.hasOwnProperty("properties")){n(d,s)}else{d.properties[a]=s}return r},mergePersistObjects:function(e){if(e){var t=["merge","remove"];t.forEach(function(t){(e[t]||[]).forEach(function(e){var n=Object.keys(e.properties);n.forEach(function(i){r.persist(e.objectName,i,e.properties[i],t,e.selector,e.displayName,n.length<=1)})})})}},build:function(){return e}};return r}Object.defineProperty(t,"__esModule",{value:true});t.default=i},function(e,t,r){"use strict";var n=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};r(1);var i=r(23);function o(e){"use strict";if(e===void 0){e=false}return function t(r){"use strict";var o=function(t){n(r,t);function r(){var e=t.apply(this,arguments)||this;e.__receivingUpdateType=false;return e}r.prototype.update=function(r){var n=!this.__receivingUpdateType;this.__receivingUpdateType=true;if(t.prototype.update){t.prototype.update.call(this,r)}if(n){this.__receivingUpdateType=true;var o=i.default(this.__prevOptions,r,e);this.updateWithType(r,o);this.__prevOptions=r;this.__receivingUpdateType=false}};return r}(r);return o}}t.receiveUpdateType=o},function(e,t,r){"use strict";r(1);var n=r(3);function i(e){"use strict";if(e){var t=e.serializedExpr;if(t){var r=n(powerbi,"data.services.SemanticQuerySerializer",{deserializeExpr:JSON.parse});var i=r.deserializeExpr(t);var o=n(i,"left.source");if(o&&!o.schema){o.schema=undefined}return i}else{throw new Error("Not a valid serialized expression")}}}t.deserializeExpr=i},function(e,t,r){"use strict";r(1);var n=r(54);function i(e){"use strict";if(e){var t=e.serializedIdentity;if(t){var r=n.deserializeExpr(t.expr);return powerbi.data.createDataViewScopeIdentity(r)}}return e}t.deserializeIdentity=i},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}n(r(54));n(r(25));n(r(57));n(r(55));n(r(103));n(r(102));n(r(104))},function(e,t,r){"use strict";r(1);var n=r(25);function i(e){"use strict";var t=e;if(t&&!t.serializedIdentity){return{serializedIdentity:{expr:n.serializeExpr(e.expr)}}}return t}t.serializeIdentity=i},function(e,t,r){var n=r(29),i=r(4);var o=n(i,"Map");e.exports=o},function(e,t,r){var n=r(150),i=r(151),o=r(152),a=r(153),s=r(154);function u(e){var t=-1,r=e==null?0:e.length;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n;u.prototype["delete"]=i;u.prototype.get=o;u.prototype.has=a;u.prototype.set=s;e.exports=u},function(e,t,r){var n=r(28),i=r(18);function o(e,t,r){if(r!==undefined&&!i(e[t],r)||r===undefined&&!(t in e)){n(e,t,r)}}e.exports=o},function(e,t,r){var n=r(28),i=r(18);var o=Object.prototype;var a=o.hasOwnProperty;function s(e,t,r){var o=e[t];if(!(a.call(e,t)&&i(o,r))||r===undefined&&!(t in e)){n(e,t,r)}}e.exports=s},function(e,t,r){var n=r(12),i=r(142),o=r(168),a=r(178);function s(e,t){if(n(e)){return e}return i(e,t)?[e]:o(a(e))}e.exports=s},function(e,t,r){var n=r(61),i=r(28);function o(e,t,r,o){var a=!r;r||(r={});var s=-1,u=t.length;while(++s<u){var l=t[s];var c=o?o(r[l],e[l],l,r,e):undefined;if(c===undefined){c=e[l]}if(a){i(r,l,c)}else{n(r,l,c)}}return r}e.exports=o},function(e,t,r){var n=r(121),i=r(141);function o(e){return n(function(t,r){var n=-1,o=r.length,a=o>1?r[o-1]:undefined,s=o>2?r[2]:undefined;a=e.length>3&&typeof a=="function"?(o--,a):undefined;if(s&&i(r[0],r[1],s)){a=o<3?undefined:a;o=1}t=Object(t);while(++n<o){var u=r[n];if(u){e(t,u,n,a)}}return t})}e.exports=o},function(e,t,r){var n=r(29);var i=function(){try{var e=n(Object,"defineProperty");e({},"",{});return e}catch(e){}}();e.exports=i},function(e,t){(function(t){var r=typeof t=="object"&&t&&t.Object===Object&&t;e.exports=r}).call(t,function(){return this}())},function(e,t,r){var n=r(159);var i=n(Object.getPrototypeOf,Object);e.exports=i},function(e,t){var r=Object.prototype;function n(e){var t=e&&e.constructor,n=typeof t=="function"&&t.prototype||r;return e===n}e.exports=n},function(e,t,r){var n=r(33);var i=1/0;function o(e){if(typeof e=="string"||n(e)){return e}var t=e+"";return t=="0"&&1/e==-i?"-0":t}e.exports=o},function(e,t){function r(e){return e}e.exports=r},function(e,t,r){var n=r(115),i=r(5);var o=Object.prototype;var a=o.hasOwnProperty;var s=o.propertyIsEnumerable;var u=n(function(){return arguments}())?n:function(e){return i(e)&&a.call(e,"callee")&&!s.call(e,"callee")};e.exports=u},function(e,t,r){(function(e){var n=r(4),i=r(176);var o=typeof t=="object"&&t&&!t.nodeType&&t;var a=o&&typeof e=="object"&&e&&!e.nodeType&&e;var s=a&&a.exports===o;var u=s?n.Buffer:undefined;var l=u?u.isBuffer:undefined;var c=l||i;e.exports=c}).call(t,r(37)(e))},function(e,t){var r=9007199254740991;function n(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=r}e.exports=n},function(e,t,r){var n=r(117),i=r(126),o=r(157);var a=o&&o.isTypedArray;var s=a?i(a):n;e.exports=s},function(e,t){e.exports=function(){var e=[];e.toString=function e(){var t=[];for(var r=0;r<this.length;r++){var n=this[r];if(n[2]){t.push("@media "+n[2]+"{"+n[1]+"}")}else{t.push(n[1])}}return t.join("")};e.i=function(t,r){if(typeof t==="string")t=[[null,t,""]];var n={};for(var i=0;i<this.length;i++){var o=this[i][0];if(typeof o==="number")n[o]=true}for(i=0;i<t.length;i++){var a=t[i];if(typeof a[0]!=="number"||!n[a[0]]){if(r&&!a[2]){a[2]=r}else if(r){a[2]="("+a[2]+") and ("+r+")"}e.push(a)}}};return e}},function(e,t){t=e.exports=r;t.getSerialize=n;function r(e,t,r,i){return JSON.stringify(e,n(t,i),r)}function n(e,t){var r=[],n=[];if(t==null)t=function(e,t){if(r[0]===t)return"[Circular ~]";return"[Circular ~."+n.slice(0,r.indexOf(t)).join(".")+"]"};return function(i,o){if(r.length>0){var a=r.indexOf(this);~a?r.splice(a+1):r.push(this);~a?n.splice(a,Infinity,i):n.push(i);if(~r.indexOf(o))o=t.call(this,i,o)}else r.push(o);return e==null?o:e.call(this,i,o)}}},function(e,t,r){var n=r(185);function i(e,t,r){var i=e==null?undefined:n(e,t);return i===undefined?r:i}e.exports=i},function(e,t){var r=Array.isArray;e.exports=r},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:true});r(1);var n=r(80);var i=r(19);var o=r(77);var a=/#[0-9A-F]{3,6}/;var s=/rgba?\s*\(\s*[\d\.]+\s*,\s*[\d\.]+\s*,\s*[\d\.]+\s*(,\s*[\d\.]+\s*)?\)/;function u(e,t,r,o){"use strict";if(e&&e.categorical){if(!t){t=n.createValueFormatter()}if(!r){r=n.createCategoryFormatter(e)}var a=l(e);var s=i.convertItemsWithSegments(e,function(e,n,i,o,s){o=powerbi.visuals.SelectionIdBuilder?(new powerbi.visuals.SelectionIdBuilder).withCategory(e[0],n).createSelectionId():o;var u=d(c(e,n,r),i,o.getKey(),o.getSelector(),undefined,"#ccc");(s||[]).forEach(function(e,r){e.color=a[r]||e.color;e.displayValue=t.format(e.value)});return u},h(e)?o:undefined);return s}}t.default=u;function l(e){"use strict";var t=e.categorical.values;var r=t&&t.grouped();var n={};if(e.metadata.columns.filter(function(e){return e.roles["Color"]}).length>=0&&r){r.forEach(function(e,t){var r=(e.name||"")+"";if(r&&(a.test(r)||s.test(r))){n[t]=r}})}return n}t.calculateSegmentColorsFromData=l;function c(e,t,r){"use strict";return(e||[]).map(function(e){var n=e.values[t];return r?r.format(n):n}).join(" - ")}t.buildCategoryDisplay=c;function f(e){"use strict";if(e){return d(e.match,e.value,e.id,e.selector,e.renderedValue,undefined,true)}}t.createItemFromSerializedItem=f;function d(e,t,r,n,o,a,s){"use strict";if(a===void 0){a=""}if(s===void 0){s=false}return{id:r,match:e,color:a,value:t||0,renderedValue:o,selector:s?n:i.serializeSelectors([n])[0],equals:function(e){return r===e.id}}}t.createItem=d;function p(e){"use strict";return o(e,"categorical.values.length",0)>0}t.dataSupportsValueSegments=p;function h(e){"use strict";if(p(e)){var t=e.categorical.values.grouped();return t.filter(function(e){return!!e.identity}).length>0}return false}t.dataSupportsColorizedInstances=h},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:true});var r=powerbi.visuals.valueFormatter.create;function n(e,t){"use strict";if(e===void 0){e=0}if(t===void 0){t=0}return r({value:e,format:"0",precision:t})}t.createValueFormatter=n;function i(e){"use strict";var t;var n=e&&e.categorical&&e.categorical.categories;if(n&&n.length&&n[0].source.type.dateTime){var i;var o;n[0].values.forEach(function(e){if(typeof i==="undefined"||i>e){i=new Date(e.valueOf())}if(typeof o==="undefined"||o<e){o=new Date(e.valueOf())}});if(i&&o){t=r({value:i,value2:o,format:n[0].source.format||"0"})}}return t}t.createCategoryFormatter=i},function(e,t){var r=Array.isArray;e.exports=r},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:true});t.SEARCH_DEBOUNCE=500;t.DEFAULT_VALUE_WIDTH=66;t.DEFAULT_TEXT_SIZE=12;t.DEFAULT_STATE={selectedItems:[],searchText:"",labelDisplayUnits:0,labelPrecision:0,horizontal:false,valueColumnWidth:t.DEFAULT_VALUE_WIDTH,showSelections:true,singleSelect:false,brushMode:false,textSize:t.DEFAULT_TEXT_SIZE,itemTextColor:"#000",leftAlignText:false,showOptions:true,showSearch:true,searchSupported:true,showValues:true,scrollPosition:[0,0],displayValueLabels:false,overflowValueLabels:false}},function(e,t,r){"use strict";var n=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r]};return function(t,r){e(t,r);function n(){this.constructor=t}t.prototype=r===null?Object.create(r):(n.prototype=r.prototype,new n)}}();Object.defineProperty(t,"__esModule",{value:true});var i=r(84);var o=r(7);var a=".selection-manager";var s=function(e){n(t,e);function t(){return e!==null&&e.apply(this,arguments)||this}t.prototype.bindTo=function(e,t,r,n){var i=this;this.listEle=e;this.itemSelector=t;this.eleItemGetter=r;this.itemEleGetter=n;e.on("contextmenu"+a,function(e){return i.endDrag()});e.on("selectstart"+a,function(e){return false});e.on("mouseenter"+a,function(e){e.stopPropagation();i.endDrag()});e.on("mouseleave"+a,function(){return i.endDrag()});e.on("mousedown"+a,function(e){e.stopPropagation();i.keyPressed({ctrl:e.ctrlKey,shift:e.shiftKey});var r=e.which||e["buttons"];if(r===1){var n=o(e.target);if(!n.is(t)){n=n.parents(".item")}if(n.is(t)){i.mouseDownEle=n;i.lastMouseDownX=e.clientX;i.lastMouseDownY=e.clientY}}});e.on("mouseup"+a,function(e){e.stopPropagation();i.keyPressed({ctrl:e.ctrlKey,shift:e.shiftKey});i.lastMouseDownX=undefined;i.lastMouseDownY=undefined;if(i._dragging){i.endDrag()}});e.on("mousemove"+a,function(e){e.stopPropagation();var t=e.which||e["buttons"];if(t!==1){i.endDrag()}else if(typeof i.lastMouseDownX!=="undefined"&&(Math.abs(e.clientX-i.lastMouseDownX)>=10||Math.abs(e.clientY-i.lastMouseDownY))&&!i._dragging){i.startDrag();var r=i.eleItemGetter(i.mouseDownEle);if(r){i.itemHovered(r)}}});this.refresh();return function(){var r;e.off(a);e.find(t).off(a);i.listEle=r;i.itemSelector=r;i.eleItemGetter=r;i.lastMouseDownX=r;i.lastMouseDownY=r;i.mouseDownEle=r}};t.prototype.destroy=function(){o(window).off(a);if(this.listEle){this.listEle.off(a).find(this.itemSelector).off(a)}};t.prototype.startDrag=function(){e.prototype.startDrag.call(this);if(this.brushMode){this.listEle.find(this.itemSelector).removeClass("selected-slicer-item")}};t.prototype.endDrag=function(){var t;this.lastMouseDownX=t;this.lastMouseDownY=t;this.mouseDownEle=t;e.prototype.endDrag.call(this)};t.prototype.refresh=function(){var e=this;if(this.listEle){var t=this;this.listEle.find(this.itemSelector).off(a).on("selectstart"+a,function(e){return false}).on("mouseenter"+a,function(e){e.stopPropagation();t.itemHovered(t.eleItemGetter(o(this)))}).on("click"+a,function(e){e.stopPropagation();t.keyPressed({ctrl:e.ctrlKey,shift:e.shiftKey});t.itemClicked(t.eleItemGetter(o(this)))}).each(function(t,r){var n=e.eleItemGetter(o(r));var i=e.findIndex(n,e._dragging&&e.brushMode?e._brushingSelection:e.selection)>=0;o(r).toggleClass("selected-slicer-item",i)})}};t.prototype.itemHovered=function(t){var r=this;var n=e.prototype.itemHovered.call(this,t);if(this.itemEleGetter){n.removed.forEach(function(e){o(r.itemEleGetter(e)).removeClass("selected-slicer-item")});n.added.forEach(function(e){o(r.itemEleGetter(e)).addClass("selected-slicer-item")})}return n};t.prototype.setSelection=function(t){var r=e.prototype.setSelection.call(this,t);if(r){this.refresh()}return r};return t}(i.default);t.default=s},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:true});var r=function(){function e(e){this._selectionDontUseDirectly=[];this._brushingSelection=[];this.keyState={};this._dragging=false;this._brushMode=false;this._singleSelectDontUse=false;this.selectionListener=e}Object.defineProperty(e.prototype,"items",{get:function(){return this._items},set:function(e){this._items=e||[]},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"selection",{get:function(){return this._selectionDontUseDirectly},set:function(e){this.setSelection(e)},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"singleSelect",{get:function(){return this._singleSelectDontUse},set:function(e){this._singleSelectDontUse=e;this.selection=this.selection.slice(0)},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"brushingSelection",{get:function(){return this._brushingSelection},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"dragging",{get:function(){return this._dragging},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"brushMode",{get:function(){return this._brushMode},set:function(e){this._brushMode=e},enumerable:true,configurable:true});e.prototype.itemHovered=function(e){var t=this;var r={added:[],removed:[]};if(this._dragging&&this._brushMode){if(this._brushingSelection.length>=1&&this.items&&this.items.length){var n;var i;var o=this._brushingSelection.slice(0);if(this.findIndex(e,o)>-1){o.splice(o.indexOf(this._previousBrushedItem),1);r.removed.push(this._previousBrushedItem)}else{o.push(e);r.added.push(e)}o.forEach(function(e){var r=t._items.indexOf(e);if(typeof n==="undefined"||r<n){n=r}if(typeof i==="undefined"||r>i){i=r}});this._brushingSelection=this.items.slice(n,i+1)}else if(this.findIndex(e,this._brushingSelection)<0){this._brushingSelection.push(e);r.added.push(e)}this._previousBrushedItem=e}return r};e.prototype.itemClicked=function(e){var t=this;var r=function(){var r=t.findIndex(e);var n=t.selection.slice(0);if(r<0){n.push(e)}else{n.splice(r,1)}t.selection=n};if(!this.keyState.ctrl){if(this.keyState.shift&&!this.shiftPivot){this.shiftPivot=e}if(this.keyState.shift&&this.items&&this.items.length){var n=this.findIndex(this.shiftPivot,this.items);var i=this.findIndex(e,this.items);
this.selection=this.items.slice(n<i?n:i,(n<i?i:n)+1)}else if(this._brushMode){this.selection=this.selection.length===1&&this.selection[0].equals(e)?[]:[e]}else{r()}}else{r()}};e.prototype.keyPressed=function(e){this.keyState.ctrl=e.ctrl;if(this.keyState.shift!==e.shift){if(e.shift){this.shiftPivot=this.selection[this.selection.length-1]}else{delete this.shiftPivot}this.keyState.shift=e.shift}};e.prototype.startDrag=function(){this._dragging=true;this._brushingSelection=[]};e.prototype.endDrag=function(){if(this._dragging){this._dragging=false;if(this.brushMode){if(this.keyState.ctrl){this._brushingSelection=this._brushingSelection.concat(this.selection)}this.selection=this._brushingSelection.slice(0)}this._brushingSelection=[]}};e.prototype.findIndex=function(e,t){if(!t){t=this.selection}for(var r=0;r<t.length;r++){var n=t[r];if(n.equals(e)){return r}}return-1};e.prototype.setSelection=function(e){e=e||[];if(this.singleSelect&&e.length){e=[e[e.length-1]]}var t=this.selection||[];var r=e;var n=t.filter(function(e){return r.filter(function(t){return e.equals(t)}).length===0}).length>0;n=n||r.filter(function(e){return t.filter(function(t){return e.equals(t)}).length===0}).length>0;if(n){this._selectionDontUseDirectly=e;if(this.selectionListener){this.selectionListener(e)}return true}return false};return e}();t.default=r},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}Object.defineProperty(t,"__esModule",{value:true});var i=r(208);t.AttributeSlicer=i.AttributeSlicer;n(r(38));var o=r(83);t.JQuerySelectionManager=o.default;var a=r(84);t.SelectionManager=a.default;n(r(82))},function(e,t){e.exports=d3},function(e,t,r){"use strict";var n=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};var i=this&&this.__decorate||function(e,t,r,n){var i=arguments.length,o=i<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,r):n,a;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")o=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)if(a=e[s])o=(i<3?a(o):i>3?a(t,r,o):a(t,r))||o;return i>3&&o&&Object.defineProperty(t,r,o),o};r(1);var o=r(50);var a=r(39);var s=r(53);var u=r(7);var l=r(35)("essex:PbiBase");var c=f=function(e){n(t,e);function t(t,n){if(n===void 0){n=false}var i=e.call(this,t)||this;o.logger.addWriter(o.elementLogWriter(function(){var e=i.element.find(".logArea");e.css({display:"block"});return e}));if(!n){i.cssModule=r(179)}i.element=u("<div class='visual-base' style='height:100%;width:100%;'/>");i.element.append(u('<div class="logArea"></div>'));var a=i.getExternalCssResources().map(function(e){return i.buildExternalCssLink(e)});u.when.apply(u,a).then(function(){var e=[];for(var t=0;t<arguments.length;t++){e[t]=arguments[t]}return i.element.append(e.map(function(e){return u(e)}))});i.element.append(u("<st"+"yle>"+i.getCss().join("\n")+"</st"+"yle>"));if(i.template){i.element=i.element.append(u(i.template))}return i}Object.defineProperty(t.prototype,"template",{get:function(){return""},enumerable:true,configurable:true});t.prototype.doInit=function(e){this.width=e.viewport.width;this.height=e.viewport.height;this.container=e.element;this.attach(typeof this.loadSandboxed!=="undefined"?this.loadSandboxed:f.DEFAULT_SANDBOX_ENABLED)};t.prototype.updateWithType=function(e,t){this.width=e.viewport.width;this.height=e.viewport.height;var r=e.dataViews&&e.dataViews[0];if(r){if(f.EXPERIMENTAL_ENABLED){var n=r.metadata.objects;var i=n&&n["experimental"];var o=i&&i["sandboxed"];o=typeof o==="undefined"?f.DEFAULT_SANDBOX_ENABLED:o;if(this.sandboxed!==o){this._sandboxed=!!o}}}this.parent.css({width:this.width,height:this.height})};t.prototype.handleEnumerateObjectInstances=function(e){if(e.objectName==="experimental"&&f.EXPERIMENTAL_ENABLED){return[{selector:null,objectName:"experimental",properties:{sandboxed:this.sandboxed}}]}return[]};t.prototype.attach=function(e){var t=this;this._sandboxed=e;this.element.detach();var r=function(e){var r=t.cssModule&&t.cssModule.locals&&t.cssModule.locals.className;if(e&&r){l("Attach::Adding Classes");e.addClass(r)}};if(this.parent){l("Attach::Remove Parent");this.parent.remove()}if(e){l("Attach::Sandboxed");this.parent=u('<iframe style="width:'+this.width+"px;height:"+this.height+'px;border:0;margin:0;padding:0" frameBorder="0"/>');this.container.append(this.parent);if(typeof navigator!=="undefined"&&navigator.userAgent.toLowerCase().indexOf("firefox")>-1){l("Attach::Firefox or No Navigator");this.parent[0].onload=function(){setTimeout(function(){t.HACK_fonts();t.parent.contents().find("body").append(t.element);r(t.parent.contents().find("html"))},0)}}else{l("Attach::Not Firefox");this.parent.contents().find("head").append(u('<meta http-equiv="X-UA-Compatible" content="IE=edge">'));this.parent.contents().find("body").append(this.element);this.HACK_fonts();r(this.parent.contents().find("html"))}}else{l("Attach::Not Sandboxed");this.parent=u('<div style="width:'+this.width+"px;height:"+this.height+'px;border:0;margin:0;padding:0"/>');this.parent.append(this.element);this.container.append(this.parent);r(this.parent)}};Object.defineProperty(t.prototype,"sandboxed",{get:function(){return this._sandboxed},enumerable:true,configurable:true});t.prototype.getCss=function(){return this.cssModule?[this.cssModule+""]:[]};t.prototype.buildExternalCssLink=function(e){var t="li"+"nk";var r=e.integrity?'integrity="'+e.integrity+'"':"";var n='href="'+e.url+'"';var i=e.crossorigin?' crossorigin="'+e.crossorigin+'"':"";var o='rel="stylesheet"';var a=u.Deferred();a.resolve("<"+t+" "+n+" "+o+" "+r+" "+i+">");return a.promise()};t.prototype.getExternalCssResources=function(){return[]};t.prototype.HACK_fonts=function(){var e=this.HACK_getFontFaces();this.element.prepend(u("<st"+"yle>"+Object.keys(e).map(function(t){return e[t].cssText}).join("\n")+"</st"+"yle>"))};t.prototype.HACK_getFontFaces=function(e){var t=document.styleSheets;var r=t.length;var n={};while(0<=--r){try{var i=t[r]["rules"]||t[r]["cssRules"]||[];var o=i.length;while(0<=--o){if(i[o].constructor.name==="CSSFontFaceRule"||i[o].constructor.toString().indexOf("CSSFontFaceRule")>=0){var a=i[o].style;var s=a.fontFamily;if(!s&&a.getPropertyValue){s=a.getPropertyValue("font-family")}n[s]=i[o]}}}catch(e){if(e.name!=="SecurityError"){throw e}}}return n};return t}(a.CatchingVisualBase);c.EXPERIMENTAL_ENABLED=false;c.DEFAULT_SANDBOX_ENABLED=window.parent===window;c.capabilities=f.EXPERIMENTAL_ENABLED?{objects:{experimental:{displayName:"Experimental",properties:{sandboxed:{type:{bool:true},displayName:"Enable to sandbox the visual into an IFrame"}}}}}:{};c=f=i([s.receiveUpdateType()],c);Object.defineProperty(t,"__esModule",{value:true});t.default=c;var f},function(e,t,r){"use strict";var n=r(9);var i=r(40);function o(e){"use strict";return n.settings(i.ColoredObjectsSettings,e)}t.coloredObjectsSettings=o},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}n(r(40));n(r(88))},function(e,t,r){"use strict";var n=r(9);var i=r(42);function o(e){"use strict";return n.settings(i.GradientSettings,e)}t.gradientSetting=o},function(e,t,r){"use strict";function n(e){for(var r in e)if(!t.hasOwnProperty(r))t[r]=e[r]}n(r(8));n(r(9));n(r(20));n(r(41));n(r(44));n(r(21));n(r(43));n(r(89))},function(e,t){"use strict";function r(e){"use strict";return function(t){(function(r){var n;(function(r){var n;(function(r){var n=e.visualName+e.projectId;r[n]={name:n,class:n,capabilities:t.capabilities,custom:true,create:function(){return new t}}})(n=r.plugins||(r.plugins={}))})(n=r.visuals||(r.visuals={}))})(window["powerbi"]||(window["powerbi"]={}))}}Object.defineProperty(t,"__esModule",{value:true});t.default=r},function(e,t,r){"use strict";r(1);var n=powerbi.data;function i(e,t){"use strict";var r;var i;if(e){var o=e.type;if(t){if(o.text){var a=n.SQExprBuilder.text(t);r=n.SQExprBuilder.contains(e["expr"],a)}else{var s=void 0;if(o.numeric){s=n.SQExprBuilder.typedConstant(parseFloat(t),o)}else if(o.bool){s=n.SQExprBuilder.boolean(t==="1"||t==="true")}if(s){r=n.SQExprBuilder.equal(e["expr"],s)}}}if(r){i=n.SemanticFilter.fromSQExpr(r)}}return i}Object.defineProperty(t,"__esModule",{value:true});t.default=i},function(e,t,r){"use strict";r(1);function n(e){"use strict";return function t(r){"use strict";r.capabilities=e;return r}}t.capabilities=n},function(e,t,r){"use strict";var n=r(45);function i(e,t){"use strict";return new n.default(e,t)}Object.defineProperty(t,"__esModule",{value:true});t.default=i},function(e,t,r){(function(e){"use strict";var n=!!e.env.VISUAL_DEBUG;var i=r(47);function o(e){"use strict";var t=this;return function(){var r=[];for(var o=0;o<arguments.length;o++){r[o]=arguments[o]}if(n){var a=e();if(a){e().prepend($("<div>"+i.default.apply(t,r)+"</div>"))}}}}Object.defineProperty(t,"__esModule",{value:true});t.default=o}).call(t,r(36))},function(e,t){"use strict";function r(e,t,r){"use strict";if(t===e){return false}if(!t||!e||t.length!==e.length){return true}return _.some(e,function(e){return!_.some(t,function(t){return r(t,e)})})}Object.defineProperty(t,"__esModule",{value:true});t.default=r},function(e,t){"use strict";function r(e,t,r){"use strict";e=e||[];t=t||[];var n;var i=false;var o;var a;for(var s=e.length-1;s>=0;s--){n=e[s];i=false;for(var u=0;u<t.length;u++){o=t[u];if(r.equals(o,n)){i=true}}if(!i){e.splice(s,1);if(r.onRemove){r.onRemove(n)}}}n=undefined;for(var s=0;s<t.length;s++){o=t[s];a=undefined;for(var u=0;u<e.length;u++){n=e[u];if(r.equals(o,n)){a=n}}if(!a){e.push(o);if(r.onAdd){r.onAdd(o)}}else if(r.onUpdate){r.onUpdate(a,o)}}}Object.defineProperty(t,"__esModule",{value:true});t.default=r},function(e,t,r){"use strict";var n=r(51);var i=n.logger("essex:widget:Utils");Object.defineProperty(t,"__esModule",{value:true});t.default=i},function(e,t,r){"use strict";r(1);var n=r(49);var i=powerbi.visuals.SelectionId;var o=r(3);function a(e,t,r){"use strict";if(t===void 0){t="general.selection"}if(r===void 0){r="general.filter"}var a=o(e,t);var s=a?JSON.parse(a):[];var u=[];if(s&&s.length){var l=o(e,r+".whereItems[0].condition");var c=o(l,"values");var f=o(l,"args");if(c&&f&&c.length&&f.length){var d=f[0];u=c.map(function(e){return i.createWithId(powerbi.data.createDataViewScopeIdentity(powerbi.data.SQExprBuilder.compare(0,d,e[0])))})}else{u=n.getSelectionIdsFromSelectors(s.filter(function(e){return!!e.selector}).map(function(e){return e.selector}))}}return u}Object.defineProperty(t,"__esModule",{value:true});t.default=a},function(e,t){"use strict";var r=this&&this.__extends||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r];function n(){this.constructor=e}e.prototype=t===null?Object.create(t):(n.prototype=t.prototype,new n)};function n(e){"use strict";var t=function(e){r(t,e);function t(){var t=[];for(var r=0;r<arguments.length;r++){t[r]=arguments[r]}var n;t=t||[];n=e.apply(this,t)||this;return n}t.prototype.init=function(t){e.prototype.init.call(this,t);var r=t.viewport,n=r.width,i=r.height;this.setDimensions({width:n,height:i})};t.prototype.update=function(t){var r=t.viewport,n=r.width,i=r.height;this.setDimensions({width:n,height:i});if(e.prototype.update){e.prototype.update.call(this,t)}};return t}(e);return t}t.receiveDimensions=n},function(e,t,r){"use strict";r(1);var n=r(55);function i(e){"use strict";if(e){e.identity=n.deserializeIdentity(e.identity);return e}}t.deserializeObjectWithIdentity=i},function(e,t,r){"use strict";r(1);var n=r(57);function i(e){"use strict";if(e){e.identity=n.serializeIdentity(e.identity);return e}}t.serializeObjectWithIdentity=i},function(e,t,r){"use strict";r(1);var n=r(25);function i(e){"use strict";return(e||[]).map(function(e){return{id:e.id,metadata:e.metadata,data:e.data.map(function(e){var t=e["expr"]||e["_expr"];if(t){return n.serializeExpr(t)}else{throw new Error("serializeSelectors requires a selector built from a DataViewScopeIdentity")}})}})}t.serializeSelectors=i},function(e,t,r){"use strict";r(1);var n=r(22);var i=r(23);var o=r(99);function a(e,t){"use strict";var r=n.default.Unknown;if(e&&e.update){var a=e.update;var s;e.update=function(e){var u=i.default(s,e,t);r=u;s=e;o.default("Update -- Type: "+n.default[u]);return a.call(this,e)}}return function(){return r}}Object.defineProperty(t,"__esModule",{value:true});t.default=a},function(e,t,r){var n=r(135),i=r(136),o=r(137),a=r(138),s=r(139);function u(e){var t=-1,r=e==null?0:e.length;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}u.prototype.clear=n;u.prototype["delete"]=i;u.prototype.get=o;u.prototype.has=a;u.prototype.set=s;e.exports=u},function(e,t,r){var n=r(14),i=r(163),o=r(164),a=r(165),s=r(166),u=r(167);function l(e){var t=this.__data__=new n(e);this.size=t.size}l.prototype.clear=i;l.prototype["delete"]=o;l.prototype.get=a;l.prototype.has=s;l.prototype.set=u;e.exports=l},function(e,t,r){var n=r(4);var i=n.Uint8Array;e.exports=i},function(e,t){function r(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}e.exports=r},function(e,t,r){var n=r(124),i=r(71),o=r(12),a=r(72),s=r(30),u=r(74);var l=Object.prototype;var c=l.hasOwnProperty;function f(e,t){var r=o(e),l=!r&&i(e),f=!r&&!l&&a(e),d=!r&&!l&&!f&&u(e),p=r||l||f||d,h=p?n(e.length,String):[],v=h.length;for(var g in e){if((t||c.call(e,g))&&!(p&&(g=="length"||f&&(g=="offset"||g=="parent")||d&&(g=="buffer"||g=="byteLength"||g=="byteOffset")||s(g,v)))){h.push(g)}}return h}e.exports=f},function(e,t){function r(e,t){var r=-1,n=e==null?0:e.length,i=Array(n);while(++r<n){i[r]=t(e[r],r,e)}return i}e.exports=r},function(e,t,r){var n=r(2);var i=Object.create;var o=function(){function e(){}return function(t){if(!n(t)){return{}}if(i){return i(t)}e.prototype=t;var r=new e;e.prototype=undefined;return r}}();e.exports=o},function(e,t,r){var n=r(132);var i=n();e.exports=i},function(e,t,r){var n=r(62),i=r(69);function o(e,t){t=n(t,e);var r=0,o=t.length;while(e!=null&&r<o){e=e[i(t[r++])]}return r&&r==o?e:undefined}e.exports=o},function(e,t,r){var n=r(10),i=r(5);var o="[object Arguments]";function a(e){return i(e)&&n(e)==o}e.exports=a},function(e,t,r){var n=r(32),i=r(144),o=r(2),a=r(169);var s=/[\\^$.*+?()[\]{}|]/g;var u=/^\[object .+?Constructor\]$/;var l=Function.prototype,c=Object.prototype;var f=l.toString;var d=c.hasOwnProperty;var p=RegExp("^"+f.call(d).replace(s,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function h(e){if(!o(e)||i(e)){return false}var t=n(e)?p:u;return t.test(a(e))}e.exports=h},function(e,t,r){var n=r(10),i=r(73),o=r(5);var a="[object Arguments]",s="[object Array]",u="[object Boolean]",l="[object Date]",c="[object Error]",f="[object Function]",d="[object Map]",p="[object Number]",h="[object Object]",v="[object RegExp]",g="[object Set]",y="[object String]",m="[object WeakMap]";var b="[object ArrayBuffer]",x="[object DataView]",_="[object Float32Array]",w="[object Float64Array]",S="[object Int8Array]",C="[object Int16Array]",A="[object Int32Array]",O="[object Uint8Array]",E="[object Uint8ClampedArray]",P="[object Uint16Array]",j="[object Uint32Array]";var T={};T[_]=T[w]=T[S]=T[C]=T[A]=T[O]=T[E]=T[P]=T[j]=true;T[a]=T[s]=T[b]=T[u]=T[x]=T[l]=T[c]=T[f]=T[d]=T[p]=T[h]=T[v]=T[g]=T[y]=T[m]=false;function D(e){return o(e)&&i(e.length)&&!!T[n(e)]}e.exports=D},function(e,t,r){var n=r(2),i=r(68),o=r(156);var a=Object.prototype;var s=a.hasOwnProperty;function u(e){if(!n(e)){return o(e)}var t=i(e),r=[];for(var a in e){if(!(a=="constructor"&&(t||!s.call(e,a)))){r.push(a)}}return r}e.exports=u},function(e,t,r){var n=r(107),i=r(60),o=r(113),a=r(120),s=r(2),u=r(34);function l(e,t,r,c,f){if(e===t){return}o(t,function(o,u){if(s(o)){f||(f=new n);a(e,t,u,r,l,c,f)}else{var d=c?c(e[u],o,u+"",e,t,f):undefined;if(d===undefined){d=o}i(e,u,d)}},u)}e.exports=l},function(e,t,r){var n=r(60),i=r(128),o=r(129),a=r(130),s=r(140),u=r(71),l=r(12),c=r(171),f=r(72),d=r(32),p=r(2),h=r(172),v=r(74),g=r(177);function y(e,t,r,y,m,b,x){var _=e[r],w=t[r],S=x.get(w);if(S){n(e,r,S);return}var C=b?b(_,w,r+"",e,t,x):undefined;var A=C===undefined;if(A){var O=l(w),E=!O&&f(w),P=!O&&!E&&v(w);C=w;if(O||E||P){if(l(_)){C=_}else if(c(_)){C=a(_)}else if(E){A=false;C=i(w,true)}else if(P){A=false;C=o(w,true)}else{C=[]}}else if(h(w)||u(w)){C=_;if(u(_)){C=g(_)}else if(!p(_)||y&&d(_)){C=s(w)}}else{A=false}}if(A){x.set(w,C);m(C,w,y,b,x);x["delete"](w)}n(e,r,C)}e.exports=y},function(e,t,r){var n=r(70),i=r(160),o=r(161);function a(e,t){return o(i(e,t,n),e+"")}e.exports=a},function(e,t,r){var n=r(61),i=r(62),o=r(30),a=r(2),s=r(69);function u(e,t,r,u){if(!a(e)){return e}t=i(t,e);var l=-1,c=t.length,f=c-1,d=e;while(d!=null&&++l<c){var p=s(t[l]),h=r;if(l!=f){var v=d[p];h=u?u(v,p,d):undefined;if(h===undefined){h=a(v)?v:o(t[l+1])?[]:{}}}n(d,p,h);d=d[p]}return e}e.exports=u},function(e,t,r){var n=r(170),i=r(65),o=r(70);var a=!i?o:function(e,t){return i(e,"toString",{configurable:true,enumerable:false,value:n(t),writable:true})};e.exports=a},function(e,t){function r(e,t){var r=-1,n=Array(e);while(++r<e){n[r]=t(r)}return n}e.exports=r},function(e,t,r){var n=r(27),i=r(111),o=r(12),a=r(33);var s=1/0;var u=n?n.prototype:undefined,l=u?u.toString:undefined;function c(e){if(typeof e=="string"){return e}if(o(e)){return i(e,c)+""}if(a(e)){return l?l.call(e):""}var t=e+"";return t=="0"&&1/e==-s?"-0":t}e.exports=c},function(e,t){function r(e){return function(t){return e(t)}}e.exports=r},function(e,t,r){var n=r(108);function i(e){var t=new e.constructor(e.byteLength);new n(t).set(new n(e));return t}e.exports=i},function(e,t,r){(function(e){var n=r(4);var i=typeof t=="object"&&t&&!t.nodeType&&t;var o=i&&typeof e=="object"&&e&&!e.nodeType&&e;var a=o&&o.exports===i;var s=a?n.Buffer:undefined,u=s?s.allocUnsafe:undefined;function l(e,t){if(t){return e.slice()}var r=e.length,n=u?u(r):new e.constructor(r);e.copy(n);return n}e.exports=l}).call(t,r(37)(e))},function(e,t,r){var n=r(127);function i(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}e.exports=i},function(e,t){function r(e,t){var r=-1,n=e.length;t||(t=Array(n));while(++r<n){t[r]=e[r]}return t}e.exports=r},function(e,t,r){var n=r(4);var i=n["__core-js_shared__"];e.exports=i},function(e,t){function r(e){return function(t,r,n){var i=-1,o=Object(t),a=n(t),s=a.length;while(s--){var u=a[e?s:++i];if(r(o[u],u,o)===false){break}}return t}}e.exports=r},function(e,t,r){var n=r(27);var i=Object.prototype;var o=i.hasOwnProperty;var a=i.toString;var s=n?n.toStringTag:undefined;function u(e){var t=o.call(e,s),r=e[s];try{e[s]=undefined;var n=true}catch(e){}var i=a.call(e);if(n){if(t){e[s]=r}else{delete e[s]}}return i}e.exports=u},function(e,t){function r(e,t){return e==null?undefined:e[t]}e.exports=r},function(e,t,r){var n=r(17);function i(){this.__data__=n?n(null):{};this.size=0}e.exports=i},function(e,t){function r(e){var t=this.has(e)&&delete this.__data__[e];this.size-=t?1:0;return t}e.exports=r},function(e,t,r){var n=r(17);var i="__lodash_hash_undefined__";var o=Object.prototype;var a=o.hasOwnProperty;function s(e){var t=this.__data__;if(n){var r=t[e];return r===i?undefined:r}return a.call(t,e)?t[e]:undefined}e.exports=s},function(e,t,r){var n=r(17);var i=Object.prototype;var o=i.hasOwnProperty;function a(e){var t=this.__data__;return n?t[e]!==undefined:o.call(t,e)}e.exports=a},function(e,t,r){var n=r(17);var i="__lodash_hash_undefined__";function o(e,t){var r=this.__data__;this.size+=this.has(e)?0:1;r[e]=n&&t===undefined?i:t;return this}e.exports=o},function(e,t,r){var n=r(112),i=r(67),o=r(68);function a(e){return typeof e.constructor=="function"&&!o(e)?n(i(e)):{}}e.exports=a},function(e,t,r){var n=r(18),i=r(31),o=r(30),a=r(2);function s(e,t,r){if(!a(r)){return false}var s=typeof t;if(s=="number"?i(r)&&o(t,r.length):s=="string"&&t in r){return n(r[t],e)}return false}e.exports=s},function(e,t,r){var n=r(12),i=r(33);var o=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;function s(e,t){if(n(e)){return false}var r=typeof e;if(r=="number"||r=="symbol"||r=="boolean"||e==null||i(e)){return true}return a.test(e)||!o.test(e)||t!=null&&e in Object(t)}e.exports=s},function(e,t){function r(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}e.exports=r},function(e,t,r){var n=r(131);var i=function(){var e=/[^.]+$/.exec(n&&n.keys&&n.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}();function o(e){return!!i&&i in e}e.exports=o},function(e,t){function r(){this.__data__=[];this.size=0}e.exports=r},function(e,t,r){var n=r(15);var i=Array.prototype;var o=i.splice;function a(e){var t=this.__data__,r=n(t,e);if(r<0){return false}var i=t.length-1;if(r==i){t.pop()}else{o.call(t,r,1)}--this.size;return true}e.exports=a},function(e,t,r){var n=r(15);function i(e){var t=this.__data__,r=n(t,e);return r<0?undefined:t[r][1]}e.exports=i},function(e,t,r){var n=r(15);function i(e){return n(this.__data__,e)>-1}e.exports=i},function(e,t,r){var n=r(15);function i(e,t){var r=this.__data__,i=n(r,e);if(i<0){++this.size;r.push([e,t])}else{r[i][1]=t}return this}e.exports=i},function(e,t,r){var n=r(106),i=r(14),o=r(58);function a(){this.size=0;this.__data__={hash:new n,map:new(o||i),string:new n}}e.exports=a},function(e,t,r){var n=r(16);function i(e){var t=n(this,e)["delete"](e);this.size-=t?1:0;return t}e.exports=i},function(e,t,r){var n=r(16);function i(e){return n(this,e).get(e)}e.exports=i},function(e,t,r){var n=r(16);function i(e){return n(this,e).has(e)}e.exports=i},function(e,t,r){var n=r(16);function i(e,t){var r=n(this,e),i=r.size;r.set(e,t);this.size+=r.size==i?0:1;return this}e.exports=i},function(e,t,r){var n=r(173);var i=500;function o(e){var t=n(e,function(e){if(r.size===i){r.clear()}return e});var r=t.cache;return t}e.exports=o},function(e,t){function r(e){var t=[];if(e!=null){for(var r in Object(e)){t.push(r)}}return t}e.exports=r},function(e,t,r){(function(e){var n=r(66);var i=typeof t=="object"&&t&&!t.nodeType&&t;var o=i&&typeof e=="object"&&e&&!e.nodeType&&e;var a=o&&o.exports===i;var s=a&&n.process;var u=function(){try{return s&&s.binding&&s.binding("util")}catch(e){}}();e.exports=u}).call(t,r(37)(e))},function(e,t){var r=Object.prototype;var n=r.toString;function i(e){return n.call(e)}e.exports=i},function(e,t){function r(e,t){return function(r){return e(t(r))}}e.exports=r},function(e,t,r){var n=r(109);var i=Math.max;function o(e,t,r){t=i(t===undefined?e.length-1:t,0);return function(){var o=arguments,a=-1,s=i(o.length-t,0),u=Array(s);while(++a<s){u[a]=o[t+a]}a=-1;var l=Array(t+1);while(++a<t){l[a]=o[a]}l[t]=r(u);return n(e,this,l)}}e.exports=o},function(e,t,r){var n=r(123),i=r(162);var o=i(n);e.exports=o},function(e,t){var r=800,n=16;var i=Date.now;function o(e){var t=0,o=0;return function(){var a=i(),s=n-(a-o);o=a;if(s>0){if(++t>=r){return arguments[0]}}else{t=0}return e.apply(undefined,arguments)}}e.exports=o},function(e,t,r){var n=r(14);function i(){this.__data__=new n;this.size=0}e.exports=i},function(e,t){function r(e){var t=this.__data__,r=t["delete"](e);this.size=t.size;return r}e.exports=r},function(e,t){function r(e){return this.__data__.get(e)}e.exports=r},function(e,t){function r(e){return this.__data__.has(e)}e.exports=r},function(e,t,r){var n=r(14),i=r(58),o=r(59);var a=200;function s(e,t){var r=this.__data__;if(r instanceof n){var s=r.__data__;if(!i||s.length<a-1){s.push([e,t]);this.size=++r.size;return this}r=this.__data__=new o(s)}r.set(e,t);this.size=r.size;return this}e.exports=s},function(e,t,r){var n=r(155);var i=/^\./,o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;var a=/\\(\\)?/g;var s=n(function(e){var t=[];if(i.test(e)){t.push("")}e.replace(o,function(e,r,n,i){t.push(n?i.replace(a,"$1"):r||e)});return t});e.exports=s},function(e,t){var r=Function.prototype;var n=r.toString;function i(e){if(e!=null){try{return n.call(e)}catch(e){}try{return e+""}catch(e){}}return""}e.exports=i},function(e,t){function r(e){return function(){return e}}e.exports=r},function(e,t,r){var n=r(31),i=r(5);function o(e){return i(e)&&n(e)}e.exports=o},function(e,t,r){var n=r(10),i=r(67),o=r(5);var a="[object Object]";var s=Function.prototype,u=Object.prototype;var l=s.toString;var c=u.hasOwnProperty;var f=l.call(Object);function d(e){if(!o(e)||n(e)!=a){return false}var t=i(e);if(t===null){return true}var r=c.call(t,"constructor")&&t.constructor;return typeof r=="function"&&r instanceof r&&l.call(r)==f}e.exports=d},function(e,t,r){var n=r(59);var i="Expected a function";function o(e,t){if(typeof e!="function"||t!=null&&typeof t!="function"){throw new TypeError(i)}var r=function(){var n=arguments,i=t?t.apply(this,n):n[0],o=r.cache;if(o.has(i)){return o.get(i)}var a=e.apply(this,n);r.cache=o.set(i,a)||o;return a};r.cache=new(o.Cache||n);return r}o.Cache=n;e.exports=o},function(e,t,r){var n=r(119),i=r(64);var o=i(function(e,t,r){n(e,t,r)});e.exports=o},function(e,t,r){var n=r(122);function i(e,t,r){return e==null?e:n(e,t,r)}e.exports=i},function(e,t){function r(){return false}e.exports=r},function(e,t,r){var n=r(63),i=r(34);function o(e){return n(e,i(e))}e.exports=o},function(e,t,r){var n=r(125);function i(e){return e==null?"":n(e)}e.exports=i},function(e,t,r){t=e.exports=r(75)();t.push([e.id,"._20jNmVUCNMHVUVX-mWZvE5 ::-webkit-scrollbar{width:8px;height:8px;background-color:transparent}._20jNmVUCNMHVUVX-mWZvE5 ::-webkit-scrollbar-thumb,._20jNmVUCNMHVUVX-mWZvE5 ::-webkit-scrollbar-track{background:transparent}._20jNmVUCNMHVUVX-mWZvE5 :hover::-webkit-scrollbar-thumb{background:#c8c8c8}._20jNmVUCNMHVUVX-mWZvE5 :hover::-webkit-scrollbar-track{background:transparent}._20jNmVUCNMHVUVX-mWZvE5 ::-webkit-scrollbar-track-piece{background:0 0}._20jNmVUCNMHVUVX-mWZvE5 *{-ms-overflow-style:-ms-autohiding-scrollbar;-ms-scrollbar-track-color:transparent;-ms-scrollbar-arrow-color:#c8c8c8;-ms-scrollbar-face-color:#c8c8c8}._20jNmVUCNMHVUVX-mWZvE5 * body{scrollbar-face-color:#c8c8c8;scrollbar-track-color:transparent}._20jNmVUCNMHVUVX-mWZvE5 .logArea{position:absolute;left:0;right:0;bottom:0;height:200px;overflow:auto;background-color:#fff;border-top:1px solid gray;display:none;z-index:1000}._20jNmVUCNMHVUVX-mWZvE5 body{margin:0;padding:0;overflow:hidden}",""]);t.locals={className:"_20jNmVUCNMHVUVX-mWZvE5"}},function(e,t,r){t=e.exports=r(75)();t.push([e.id,'._1tiCxlAPtTUZhuAxkCvBzF .advanced-slicer,._1tiCxlAPtTUZhuAxkCvBzF .token{font-family:Segoe UI,wf_segoe-ui_normal,helvetica,arial,sans-serif}._1tiCxlAPtTUZhuAxkCvBzF .advanced-slicer{font-size:12px}._1tiCxlAPtTUZhuAxkCvBzF ::-webkit-scrollbar{width:8px;height:8px;background-color:transparent}._1tiCxlAPtTUZhuAxkCvBzF ::-webkit-scrollbar-thumb,._1tiCxlAPtTUZhuAxkCvBzF ::-webkit-scrollbar-track{background:transparent}._1tiCxlAPtTUZhuAxkCvBzF :hover::-webkit-scrollbar-thumb{background:#c8c8c8}._1tiCxlAPtTUZhuAxkCvBzF :hover::-webkit-scrollbar-track{background:transparent}._1tiCxlAPtTUZhuAxkCvBzF ::-webkit-scrollbar-track-piece{background:0 0}._1tiCxlAPtTUZhuAxkCvBzF *{-ms-overflow-style:-ms-autohiding-scrollbar;-ms-scrollbar-track-color:transparent;-ms-scrollbar-arrow-color:#c8c8c8;-ms-scrollbar-face-color:#c8c8c8}._1tiCxlAPtTUZhuAxkCvBzF * body{scrollbar-face-color:#c8c8c8;scrollbar-track-color:transparent}._1tiCxlAPtTUZhuAxkCvBzF .logArea{position:absolute;left:0;right:0;bottom:0;height:200px;overflow:auto;background-color:#fff;border-top:1px solid gray;display:none;z-index:1000}._1tiCxlAPtTUZhuAxkCvBzF body{margin:0;padding:0;overflow:hidden}._1tiCxlAPtTUZhuAxkCvBzF .advanced-slicer{position:relative;color:#333;width:100%;height:100%;overflow:hidden}._1tiCxlAPtTUZhuAxkCvBzF .show-highlight.has-search .match{background-color:#ff0}._1tiCxlAPtTUZhuAxkCvBzF .searchbox{vertical-align:middle}._1tiCxlAPtTUZhuAxkCvBzF .clear-all{cursor:pointer;font-size:.8em;color:#34f}@-ms-keyframes attribute-slicer-ring-animation{._1tiCxlAPtTUZhuAxkCvBzF 0%{-ms-transform:rotate(0deg);-moz-transform:rotate(0deg);-webkit-transform:rotate(0deg);-o-transform:rotate(0deg);transform:rotate(0deg)}._1tiCxlAPtTUZhuAxkCvBzF to{-ms-transform:rotate(1turn);-moz-transform:rotate(1turn);-webkit-transform:rotate(1turn);-o-transform:rotate(1turn);transform:rotate(1turn)}}@-moz-keyframes attribute-slicer-ring-animation{0%{-ms-transform:rotate(0deg);-moz-transform:rotate(0deg);-webkit-transform:rotate(0deg);-o-transform:rotate(0deg);transform:rotate(0deg)}to{-ms-transform:rotate(1turn);-moz-transform:rotate(1turn);-webkit-transform:rotate(1turn);-o-transform:rotate(1turn);transform:rotate(1turn)}}@-webkit-keyframes attribute-slicer-ring-animation{0%{-ms-transform:rotate(0deg);-moz-transform:rotate(0deg);-webkit-transform:rotate(0deg);-o-transform:rotate(0deg);transform:rotate(0deg)}to{-ms-transform:rotate(1turn);-moz-transform:rotate(1turn);-webkit-transform:rotate(1turn);-o-transform:rotate(1turn);transform:rotate(1turn)}}@-o-keyframes attribute-slicer-ring-animation{0%{-ms-transform:rotate(0deg);-moz-transform:rotate(0deg);-webkit-transform:rotate(0deg);-o-transform:rotate(0deg);transform:rotate(0deg)}to{-ms-transform:rotate(1turn);-moz-transform:rotate(1turn);-webkit-transform:rotate(1turn);-o-transform:rotate(1turn);transform:rotate(1turn)}}@keyframes attribute-slicer-ring-animation{0%{-ms-transform:rotate(0deg);-moz-transform:rotate(0deg);-webkit-transform:rotate(0deg);-o-transform:rotate(0deg);transform:rotate(0deg)}to{-ms-transform:rotate(1turn);-moz-transform:rotate(1turn);-webkit-transform:rotate(1turn);-o-transform:rotate(1turn);transform:rotate(1turn)}}._1tiCxlAPtTUZhuAxkCvBzF .load-spinner>div{position:absolute;display:block;width:160px;height:160px;top:20px;left:20px;border-radius:80px;box-shadow:0 6px 0 0 #59ebff;-ms-animation:attribute-slicer-ring-animation 1s linear infinite;-moz-animation:attribute-slicer-ring-animation 1s linear infinite;-webkit-animation:attribute-slicer-ring-animation 1s linear infinite;-o-animation:attribute-slicer-ring-animation 1s linear infinite;animation:attribute-slicer-ring-animation 1s linear infinite}._1tiCxlAPtTUZhuAxkCvBzF .load-spinner{background:none;position:absolute;display:none;width:200px;height:200px;left:0;top:0;right:0;bottom:0;margin:auto;transform:scale(.6)}._1tiCxlAPtTUZhuAxkCvBzF .list{position:relative}._1tiCxlAPtTUZhuAxkCvBzF .loading{color:#ccc}._1tiCxlAPtTUZhuAxkCvBzF .loading .load-spinner{display:block}._1tiCxlAPtTUZhuAxkCvBzF .boxsized,._1tiCxlAPtTUZhuAxkCvBzF .category-container,._1tiCxlAPtTUZhuAxkCvBzF .has-values .category-container,._1tiCxlAPtTUZhuAxkCvBzF .has-values .value-container,._1tiCxlAPtTUZhuAxkCvBzF .value-container{-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box}._1tiCxlAPtTUZhuAxkCvBzF .category-container{width:100%;padding-right:2px;vertical-align:middle;text-overflow:ellipsis}._1tiCxlAPtTUZhuAxkCvBzF .value-container{width:100%;padding-right:2px;display:none;vertical-align:middle}._1tiCxlAPtTUZhuAxkCvBzF .has-values .category-container{text-align:right}._1tiCxlAPtTUZhuAxkCvBzF .has-values .value-container{display:inline-block}._1tiCxlAPtTUZhuAxkCvBzF .item{width:100%}._1tiCxlAPtTUZhuAxkCvBzF .item.selected-slicer-item{background-color:#eef}._1tiCxlAPtTUZhuAxkCvBzF .item.selected-slicer-item .display-container:before{content:"";width:2px;height:100%;background-color:#3599b8;vertical-align:middle;position:absolute;top:0}._1tiCxlAPtTUZhuAxkCvBzF .value-display{overflow:hidden}._1tiCxlAPtTUZhuAxkCvBzF .overflow{overflow:visible!important}._1tiCxlAPtTUZhuAxkCvBzF .item:hover .value-display .value,._1tiCxlAPtTUZhuAxkCvBzF .value-display .always-display.value{display:inline-block;top:.25em;bottom:0;width:100%;left:0;position:absolute;overflow:hidden;text-overflow:ellipsis}._1tiCxlAPtTUZhuAxkCvBzF .value-display .value{display:none;padding-left:3px}._1tiCxlAPtTUZhuAxkCvBzF body{margin:2px}._1tiCxlAPtTUZhuAxkCvBzF .selection-container .token{display:none}._1tiCxlAPtTUZhuAxkCvBzF .show-selections .selection-container .token{display:inline-block}._1tiCxlAPtTUZhuAxkCvBzF .token{display:inline-block;border-radius:2px;border:1px solid #666;font-size:.8em;color:#666;padding:2px;cursor:pointer;margin:2px;max-width:100px;overflow:hidden;word-wrap:break-word;white-space:nowrap;text-overflow:ellipsis;vertical-align:middle}._1tiCxlAPtTUZhuAxkCvBzF .token:hover:before{color:#efefef}._1tiCxlAPtTUZhuAxkCvBzF .token:hover{background-color:#d6d6d6}._1tiCxlAPtTUZhuAxkCvBzF .clear-all{vertical-align:middle}._1tiCxlAPtTUZhuAxkCvBzF .item{cursor:pointer}._1tiCxlAPtTUZhuAxkCvBzF .token:before{content:"\\2716";font-weight:100;margin-right:5px}._1tiCxlAPtTUZhuAxkCvBzF .category-container{margin-left:3px}._1tiCxlAPtTUZhuAxkCvBzF .value-display{background-color:#01b8aa}._1tiCxlAPtTUZhuAxkCvBzF .item.selected-slicer-item .display-container:before{background-color:#3599b8}._1tiCxlAPtTUZhuAxkCvBzF .item:hover{background-color:#c8c8c8}._1tiCxlAPtTUZhuAxkCvBzF .token{background-color:#eaeaea}._1tiCxlAPtTUZhuAxkCvBzF .searchbox{border:1px solid #999;padding-left:2px}',""]);
t.locals={className:"_1tiCxlAPtTUZhuAxkCvBzF"}},function(e,t,r){t=e.exports=o.debug=o.default=o;t.coerce=l;t.disable=s;t.enable=a;t.enabled=u;t.humanize=r(182);t.names=[];t.skips=[];t.formatters={};var n;function i(e){var r=0,n;for(n in e){r=(r<<5)-r+e.charCodeAt(n);r|=0}return t.colors[Math.abs(r)%t.colors.length]}function o(e){function r(){if(!r.enabled)return;var e=r;var i=+new Date;var o=i-(n||i);e.diff=o;e.prev=n;e.curr=i;n=i;var a=new Array(arguments.length);for(var s=0;s<a.length;s++){a[s]=arguments[s]}a[0]=t.coerce(a[0]);if("string"!==typeof a[0]){a.unshift("%O")}var u=0;a[0]=a[0].replace(/%([a-zA-Z%])/g,function(r,n){if(r==="%%")return r;u++;var i=t.formatters[n];if("function"===typeof i){var o=a[u];r=i.call(e,o);a.splice(u,1);u--}return r});t.formatArgs.call(e,a);var l=r.log||t.log||console.log.bind(console);l.apply(e,a)}r.namespace=e;r.enabled=t.enabled(e);r.useColors=t.useColors();r.color=i(e);if("function"===typeof t.init){t.init(r)}return r}function a(e){t.save(e);var r=(e||"").split(/[\s,]+/);var n=r.length;for(var i=0;i<n;i++){if(!r[i])continue;e=r[i].replace(/\*/g,".*?");if(e[0]==="-"){t.skips.push(new RegExp("^"+e.substr(1)+"$"))}else{t.names.push(new RegExp("^"+e+"$"))}}}function s(){t.enable("")}function u(e){var r,n;for(r=0,n=t.skips.length;r<n;r++){if(t.skips[r].test(e)){return false}}for(r=0,n=t.names.length;r<n;r++){if(t.names[r].test(e)){return true}}return false}function l(e){if(e instanceof Error)return e.stack||e.message;return e}},function(e,t){var r=1e3;var n=r*60;var i=n*60;var o=i*24;var a=o*365.25;e.exports=function(e,t){t=t||{};var r=typeof e;if(r==="string"&&e.length>0){return s(e)}else if(r==="number"&&isNaN(e)===false){return t.long?l(e):u(e)}throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))};function s(e){e=String(e);if(e.length>1e4){return}var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(!t){return}var s=parseFloat(t[1]);var u=(t[2]||"ms").toLowerCase();switch(u){case"years":case"year":case"yrs":case"yr":case"y":return s*a;case"days":case"day":case"d":return s*o;case"hours":case"hour":case"hrs":case"hr":case"h":return s*i;case"minutes":case"minute":case"mins":case"min":case"m":return s*n;case"seconds":case"second":case"secs":case"sec":case"s":return s*r;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return s;default:return undefined}}function u(e){if(e>=o){return Math.round(e/o)+"d"}if(e>=i){return Math.round(e/i)+"h"}if(e>=n){return Math.round(e/n)+"m"}if(e>=r){return Math.round(e/r)+"s"}return e+"ms"}function l(e){return c(e,o,"day")||c(e,i,"hour")||c(e,n,"minute")||c(e,r,"second")||e+" ms"}function c(e,t,r){if(e<t){return}if(e<t*1.5){return Math.floor(e/t)+" "+r}return Math.ceil(e/t)+" "+r+"s"}},function(e,t){(function(t){var r="Expected a function";var n="__lodash_hash_undefined__";var i=1/0;var o="[object Function]",a="[object GeneratorFunction]",s="[object Symbol]";var u=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,l=/^\w*$/,c=/^\./,f=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;var d=/[\\^$.*+?()[\]{}|]/g;var p=/\\(\\)?/g;var h=/^\[object .+?Constructor\]$/;var v=typeof t=="object"&&t&&t.Object===Object&&t;var g=typeof self=="object"&&self&&self.Object===Object&&self;var y=v||g||Function("return this")();function m(e,t){return e==null?undefined:e[t]}function b(e){var t=false;if(e!=null&&typeof e.toString!="function"){try{t=!!(e+"")}catch(e){}}return t}var x=Array.prototype,_=Function.prototype,w=Object.prototype;var S=y["__core-js_shared__"];var C=function(){var e=/[^.]+$/.exec(S&&S.keys&&S.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}();var A=_.toString;var O=w.hasOwnProperty;var E=w.toString;var P=RegExp("^"+A.call(O).replace(d,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");var j=y.Symbol,T=x.splice;var D=oe(y,"Map"),k=oe(Object,"create");var N=j?j.prototype:undefined,I=N?N.toString:undefined;function z(e){var t=-1,r=e?e.length:0;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}function V(){this.__data__=k?k(null):{}}function M(e){return this.has(e)&&delete this.__data__[e]}function U(e){var t=this.__data__;if(k){var r=t[e];return r===n?undefined:r}return O.call(t,e)?t[e]:undefined}function F(e){var t=this.__data__;return k?t[e]!==undefined:O.call(t,e)}function L(e,t){var r=this.__data__;r[e]=k&&t===undefined?n:t;return this}z.prototype.clear=V;z.prototype["delete"]=M;z.prototype.get=U;z.prototype.has=F;z.prototype.set=L;function B(e){var t=-1,r=e?e.length:0;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}function R(){this.__data__=[]}function H(e){var t=this.__data__,r=Q(t,e);if(r<0){return false}var n=t.length-1;if(r==n){t.pop()}else{T.call(t,r,1)}return true}function Z(e){var t=this.__data__,r=Q(t,e);return r<0?undefined:t[r][1]}function W(e){return Q(this.__data__,e)>-1}function $(e,t){var r=this.__data__,n=Q(r,e);if(n<0){r.push([e,t])}else{r[n][1]=t}return this}B.prototype.clear=R;B.prototype["delete"]=H;B.prototype.get=Z;B.prototype.has=W;B.prototype.set=$;function q(e){var t=-1,r=e?e.length:0;this.clear();while(++t<r){var n=e[t];this.set(n[0],n[1])}}function X(){this.__data__={hash:new z,map:new(D||B),string:new z}}function G(e){return ie(this,e)["delete"](e)}function J(e){return ie(this,e).get(e)}function K(e){return ie(this,e).has(e)}function Y(e,t){ie(this,e).set(e,t);return this}q.prototype.clear=X;q.prototype["delete"]=G;q.prototype.get=J;q.prototype.has=K;q.prototype.set=Y;function Q(e,t){var r=e.length;while(r--){if(pe(e[r][0],t)){return r}}return-1}function ee(e,t){t=ae(t,e)?[t]:ne(t);var r=0,n=t.length;while(e!=null&&r<n){e=e[ce(t[r++])]}return r&&r==n?e:undefined}function te(e){if(!ge(e)||ue(e)){return false}var t=ve(e)||b(e)?P:h;return t.test(fe(e))}function re(e){if(typeof e=="string"){return e}if(me(e)){return I?I.call(e):""}var t=e+"";return t=="0"&&1/e==-i?"-0":t}function ne(e){return he(e)?e:le(e)}function ie(e,t){var r=e.__data__;return se(t)?r[typeof t=="string"?"string":"hash"]:r.map}function oe(e,t){var r=m(e,t);return te(r)?r:undefined}function ae(e,t){if(he(e)){return false}var r=typeof e;if(r=="number"||r=="symbol"||r=="boolean"||e==null||me(e)){return true}return l.test(e)||!u.test(e)||t!=null&&e in Object(t)}function se(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}function ue(e){return!!C&&C in e}var le=de(function(e){e=be(e);var t=[];if(c.test(e)){t.push("")}e.replace(f,function(e,r,n,i){t.push(n?i.replace(p,"$1"):r||e)});return t});function ce(e){if(typeof e=="string"||me(e)){return e}var t=e+"";return t=="0"&&1/e==-i?"-0":t}function fe(e){if(e!=null){try{return A.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function de(e,t){if(typeof e!="function"||t&&typeof t!="function"){throw new TypeError(r)}var n=function(){var r=arguments,i=t?t.apply(this,r):r[0],o=n.cache;if(o.has(i)){return o.get(i)}var a=e.apply(this,r);n.cache=o.set(i,a);return a};n.cache=new(de.Cache||q);return n}de.Cache=q;function pe(e,t){return e===t||e!==e&&t!==t}var he=Array.isArray;function ve(e){var t=ge(e)?E.call(e):"";return t==o||t==a}function ge(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function ye(e){return!!e&&typeof e=="object"}function me(e){return typeof e=="symbol"||ye(e)&&E.call(e)==s}function be(e){return e==null?"":re(e)}function xe(e,t,r){var n=e==null?undefined:ee(e,t);return n===undefined?r:n}e.exports=xe}).call(t,function(){return this}())},function(e,t){(function(t){var r=t.Symbol;e.exports=r}).call(t,function(){return this}())},function(e,t,r){var n=r(186),i=r(187);function o(e,t){t=i(t,e)?[t+""]:n(t);var r=0,o=t.length;while(e!=null&&r<o){e=e[t[r++]]}return r&&r==o?e:undefined}e.exports=o},function(e,t,r){var n=r(78),i=r(188);function o(e){return n(e)?e:i(e)}e.exports=o},function(e,t,r){var n=r(78);var i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,o=/^\w*$/;function a(e,t){if(typeof e=="number"){return true}return!n(e)&&(o.test(e)||!i.test(e)||t!=null&&e in Object(t))}e.exports=a},function(e,t,r){var n=r(191);var i=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g;var o=/\\(\\)?/g;function a(e){var t=[];n(e).replace(i,function(e,r,n,i){t.push(n?i.replace(o,"$1"):r||e)});return t}e.exports=a},function(e,t){function r(e){return!!e&&typeof e=="object"}e.exports=r},function(e,t,r){(function(t){var n=r(189);var i="[object Symbol]";var o=t.Object.prototype;var a=o.toString;function s(e){return typeof e=="symbol"||n(e)&&a.call(e)==i}e.exports=s}).call(t,function(){return this}())},function(e,t,r){var n=r(184),i=r(190);var o=1/0;var a=n?n.prototype:undefined,s=n?a.toString:undefined;function u(e){if(typeof e=="string"){return e}if(e==null){return""}if(i(e)){return n?s.call(e):""}var t=e+"";return t=="0"&&1/e==-o?"-0":t}e.exports=u},function(e,t,r){"use strict";var n=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r]};return function(t,r){e(t,r);function n(){this.constructor=t}t.prototype=r===null?Object.create(r):(n.prototype=r.prototype,new n)}}();var i=this&&this.__decorate||function(e,t,r,n){var i=arguments.length,o=i<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,r):n,a;if(typeof Reflect==="object"&&typeof Reflect.decorate==="function")o=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)if(a=e[s])o=(i<3?a(o):i>3?a(t,r,o):a(t,r))||o;return i>3&&o&&Object.defineProperty(t,r,o),o};Object.defineProperty(t,"__esModule",{value:true});var o=r(19);var a=jsCommon.PixelConverter;var s=r(79);var u=r(85);var l=r(6);var c=r(77);var f=function(e){n(t,e);function t(){var t=e!==null&&e.apply(this,arguments)||this;t.scrollPosition=[0,0];return t}t.prototype.receive=function(e){throw new Error("Not implemented")};return t}(o.HasSettings);i([o.setting({name:"selfFilter",hidden:true,config:{type:{filter:{selfFilter:true}}},parse:function(e,t,r){var n=c(r,"metadata.objects.general.selfFilter");if(n){var i=c(n.where(),"[0].condition.right");return i&&i.value||""}return""},compose:function(e,t,r){return e?o.buildContainsFilter(c(r,"categorical.categories[0].source"),e):e}})],f.prototype,"searchText",void 0);i([o.setting({persist:false,parse:function(e,t,r){return c(r,"categorical.values",[]).length>0},defaultValue:u.DEFAULT_STATE.showValues})],f.prototype,"showValues",void 0);i([o.setting({persist:false,parse:function(e,t,r){var n=c(r,"metadata.objects.general.selfFilterEnabled",false);return d(r)&&!n}})],f.prototype,"searchSupported",void 0);i([o.setting({persist:false,category:"Display",displayName:"Horizontal",description:"Display the attributes horizontally, rather than vertically",defaultValue:u.DEFAULT_STATE.horizontal})],f.prototype,"horizontal",void 0);i([o.setting({persist:false,category:"Display",displayName:"Value Width %",description:"The percentage of the width that the value column should take up.",defaultValue:u.DEFAULT_STATE.valueColumnWidth})],f.prototype,"valueColumnWidth",void 0);i([o.boolSetting({persist:false,category:"Display",displayName:"Hide Empty Items",description:"Hide empty / blank Items.",defaultValue:false})],f.prototype,"hideEmptyItems",void 0);i([o.setting({name:"selection",displayName:"Selection",hidden:true,config:{type:{text:{}}},parse:function(e,t,r){return p(r)},compose:function(e,t){return h(e)}})],f.prototype,"selectedItems",void 0);i([o.setting({persist:false,displayName:"Text Size",description:"The size of the text",defaultValue:u.DEFAULT_STATE.textSize,parse:function(e){return e?a.fromPointToPixel(parseFloat(e)):u.DEFAULT_STATE.textSize},compose:function(e){return a.toPoint(e?e:u.DEFAULT_STATE.textSize)}})],f.prototype,"textSize",void 0);i([o.colorSetting({persist:false,displayName:"Text Color",description:"Item text color.",defaultValue:u.DEFAULT_STATE.itemTextColor})],f.prototype,"itemTextColor",void 0);i([o.setting({persist:false,displayName:"Text Align Left",description:"On to left align item text.",defaultValue:u.DEFAULT_STATE.leftAlignText})],f.prototype,"leftAlignText",void 0);i([o.setting({persist:false,displayName:"Show options",description:"Should the search box and other options be shown.",defaultValue:u.DEFAULT_STATE.showOptions})],f.prototype,"showOptions",void 0);i([o.setting({persist:false,displayName:"Show Search",description:"Show the search box.",defaultValue:u.DEFAULT_STATE.showSearch})],f.prototype,"showSearch",void 0);i([o.setting({persist:false,category:"Display",displayName:"Units",description:"The units to use when displaying values.",defaultValue:0,config:{type:{formatting:{labelDisplayUnits:true}}}})],f.prototype,"labelDisplayUnits",void 0);i([o.numberSetting({persist:false,category:"Display",displayName:"Precision",description:"The precision to use when displaying values.",defaultValue:0})],f.prototype,"labelPrecision",void 0);i([o.setting({persist:false,category:"Selection",displayName:"Single Select",description:"Only allow for one item to be selected at a time",defaultValue:u.DEFAULT_STATE.singleSelect})],f.prototype,"singleSelect",void 0);i([o.setting({persist:false,category:"Selection",displayName:"Brush Mode",description:"Allow for the drag selecting of attributes",defaultValue:u.DEFAULT_STATE.brushMode})],f.prototype,"brushMode",void 0);i([o.setting({persist:false,category:"Selection",displayName:"Use Tokens",description:"Will show the selected attributes as tokens",defaultValue:u.DEFAULT_STATE.showSelections})],f.prototype,"showSelections",void 0);i([o.setting({persist:false,category:"Display",displayName:"Always On Values",description:"Display value labels.",defaultValue:u.DEFAULT_STATE.displayValueLabels})],f.prototype,"displayValueLabels",void 0);i([o.setting({persist:false,category:"Display",displayName:"Overflow value text",description:"Allow value text to overflow the bar.",defaultValue:u.DEFAULT_STATE.overflowValueLabels})],f.prototype,"overflowValueLabels",void 0);i([o.coloredObjectsSettings({persist:false,category:"Data Point",enumerable:function(e,t){return s.dataSupportsColorizedInstances(t)}})],f.prototype,"colors",void 0);t.default=f;function d(e){"use strict";var t=c(e,"categorical.categories[0].source");var r=c(e,"metadata.columns");var n=r&&r.filter(function(e){return e.roles["Category"]})[0];if(t&&n){return t&&n&&n.type.text&&t.type.text}return false}function p(e){"use strict";var t=c(e,"metadata.objects");if(t){var r=o.parseSelectionIds(t);if(r&&r.length){var n=JSON.parse(c(t,"general.selection"));return r.map(function(e,t){var r=n[t],i=r.match,o=r.value,a=r.renderedValue;var u=e.getKey?e.getKey():e["key"];var l=s.createItem(i,o,u,e.getSelector(),a);return l})}return[]}else if(e){return[]}}function h(e){"use strict";if(e){return JSON.stringify((e||[]).map(function(e){return{id:e.id,match:e.match,value:e.value,selector:e.selector,renderedValue:e.renderedValue}}))}}function v(e,t){"use strict";var r=[];e=e||{};t=t||{};Object.keys(e||{}).forEach(function(n){var i=e[n];var a=t[n];if(!l.isEqual(i,a)){var s=o.getSetting(f,n);if(s){r.push(s.displayName||n)}}});return r}t.calcStateDifferences=v;function g(e){"use strict";if(e){Object.keys(e).forEach(function(t){var r=e[t];if(r&&r.forEach){r.forEach(g)}else if(r===null){e[t]=undefined}else if(typeof r==="object"){g(r)}})}}},function(e,t,r){(function(n){t=e.exports=r(194);t.log=a;t.formatArgs=o;t.save=s;t.load=u;t.useColors=i;t.storage="undefined"!=typeof window.chrome&&"undefined"!=typeof window.chrome.storage?window.chrome.storage.local:l();t.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"];function i(){if(typeof window!=="undefined"&&"process"in window&&window.process.type==="renderer"){return true}return typeof document!=="undefined"&&"WebkitAppearance"in document.documentElement.style||typeof window!=="undefined"&&window.console&&(console.firebug||console.exception&&console.table)||navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)}t.formatters.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}};function o(e){var r=this.useColors;e[0]=(r?"%c":"")+this.namespace+(r?" %c":" ")+e[0]+(r?"%c ":" ")+"+"+t.humanize(this.diff);if(!r)return;var n="color: "+this.color;e.splice(1,0,n,"color: inherit");var i=0;var o=0;e[0].replace(/%[a-z%]/g,function(e){if("%%"===e)return;i++;if("%c"===e){o=i}});e.splice(o,0,n)}function a(){return"object"===typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function s(e){try{if(null==e){t.storage.removeItem("debug")}else{t.storage.debug=e}}catch(e){}}function u(){try{return t.storage.debug}catch(e){}if(typeof n!=="undefined"&&"env"in n){return""}}t.enable(u());function l(){try{return window.localStorage}catch(e){}}}).call(t,r(36))},function(e,t,r){t=e.exports=o.debug=o.default=o;t.coerce=l;t.disable=s;t.enable=a;t.enabled=u;t.humanize=r(205);t.names=[];t.skips=[];t.formatters={};var n;function i(e){var r=0,n;for(n in e){r=(r<<5)-r+e.charCodeAt(n);r|=0}return t.colors[Math.abs(r)%t.colors.length]}function o(e){function r(){if(!r.enabled)return;var e=r;var i=+new Date;var o=i-(n||i);e.diff=o;e.prev=n;e.curr=i;n=i;var a=new Array(arguments.length);for(var s=0;s<a.length;s++){a[s]=arguments[s]}a[0]=t.coerce(a[0]);if("string"!==typeof a[0]){a.unshift("%O")}var u=0;a[0]=a[0].replace(/%([a-zA-Z%])/g,function(r,n){if(r==="%%")return r;u++;var i=t.formatters[n];if("function"===typeof i){var o=a[u];r=i.call(e,o);a.splice(u,1);u--}return r});t.formatArgs.call(e,a);var l=r.log||t.log||console.log.bind(console);l.apply(e,a)}r.namespace=e;r.enabled=t.enabled(e);r.useColors=t.useColors();r.color=i(e);if("function"===typeof t.init){t.init(r)}return r}function a(e){t.save(e);var r=(e||"").split(/[\s,]+/);var n=r.length;for(var i=0;i<n;i++){if(!r[i])continue;e=r[i].replace(/\*/g,".*?");if(e[0]==="-"){t.skips.push(new RegExp("^"+e.substr(1)+"$"))}else{t.names.push(new RegExp("^"+e+"$"))}}}function s(){t.enable("")}function u(e){var r,n;for(r=0,n=t.skips.length;r<n;r++){if(t.skips[r].test(e)){return false}}for(r=0,n=t.names.length;r<n;r++){if(t.names[r].test(e)){return true}}return false}function l(e){if(e instanceof Error)return e.stack||e.message;return e}},function(e,t){e.exports=function e(t,r){"use strict";var n=/(^([+\-]?(?:0|[1-9]\d*)(?:\.\d*)?(?:[eE][+\-]?\d+)?)?$|^0x[0-9a-f]+$|\d+)/gi,i=/(^[ ]*|[ ]*$)/g,o=/(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[\/\-]\d{1,4}[\/\-]\d{1,4}|^\w+, \w+ \d+, \d{4})/,a=/^0x[0-9a-f]+$/i,s=/^0/,u=function(t){return e.insensitive&&(""+t).toLowerCase()||""+t},l=u(t).replace(i,"")||"",c=u(r).replace(i,"")||"",f=l.replace(n,"\0$1\0").replace(/\0$/,"").replace(/^\0/,"").split("\0"),d=c.replace(n,"\0$1\0").replace(/\0$/,"").replace(/^\0/,"").split("\0"),p=parseInt(l.match(a),16)||f.length!==1&&l.match(o)&&Date.parse(l),h=parseInt(c.match(a),16)||p&&c.match(o)&&Date.parse(c)||null,v,g;if(h){if(p<h){return-1}else if(p>h){return 1}}for(var y=0,m=Math.max(f.length,d.length);y<m;y++){v=!(f[y]||"").match(s)&&parseFloat(f[y])||f[y]||0;g=!(d[y]||"").match(s)&&parseFloat(d[y])||d[y]||0;if(isNaN(v)!==isNaN(g)){return isNaN(v)?1:-1}else if(typeof v!==typeof g){v+="";g+=""}if(v<g){return-1}if(v>g){return 1}}return 0}},function(e,t,r){var n=r(198);function i(e,t,r){var i=e==null?undefined:n(e,t);return i===undefined?r:i}e.exports=i},function(e,t){(function(t){var r=t.Symbol;e.exports=r}).call(t,function(){return this}())},function(e,t,r){var n=r(199),i=r(200);function o(e,t){t=i(t,e)?[t+""]:n(t);var r=0,o=t.length;while(e!=null&&r<o){e=e[t[r++]]}return r&&r==o?e:undefined}e.exports=o},function(e,t,r){var n=r(81),i=r(201);function o(e){return n(e)?e:i(e)}e.exports=o},function(e,t,r){var n=r(81);var i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,o=/^\w*$/;function a(e,t){if(typeof e=="number"){return true}return!n(e)&&(o.test(e)||!i.test(e)||t!=null&&e in Object(t))}e.exports=a},function(e,t,r){var n=r(204);var i=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g;var o=/\\(\\)?/g;function a(e){var t=[];n(e).replace(i,function(e,r,n,i){t.push(n?i.replace(o,"$1"):r||e)});return t}e.exports=a},function(e,t){function r(e){return!!e&&typeof e=="object"}e.exports=r},function(e,t,r){(function(t){var n=r(202);var i="[object Symbol]";var o=t.Object.prototype;var a=o.toString;function s(e){return typeof e=="symbol"||n(e)&&a.call(e)==i}e.exports=s}).call(t,function(){return this}())},function(e,t,r){var n=r(197),i=r(203);var o=1/0;var a=n?n.prototype:undefined,s=n?a.toString:undefined;function u(e){if(typeof e=="string"){return e}if(e==null){return""}if(i(e)){return n?s.call(e):""}var t=e+"";return t=="0"&&1/e==-o?"-0":t}e.exports=u},function(e,t){var r=1e3;var n=r*60;var i=n*60;var o=i*24;var a=o*365.25;e.exports=function(e,t){t=t||{};var r=typeof e;if(r==="string"&&e.length>0){return s(e)}else if(r==="number"&&isNaN(e)===false){return t.long?l(e):u(e)}throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))};function s(e){e=String(e);if(e.length>1e4){return}var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(!t){return}var s=parseFloat(t[1]);var u=(t[2]||"ms").toLowerCase();switch(u){case"years":case"year":case"yrs":case"yr":case"y":return s*a;case"days":case"day":case"d":return s*o;case"hours":case"hour":case"hrs":case"hr":case"h":return s*i;case"minutes":case"minute":case"mins":case"min":case"m":return s*n;case"seconds":case"second":case"secs":case"sec":case"s":return s*r;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return s;default:return undefined}}function u(e){if(e>=o){return Math.round(e/o)+"d"}if(e>=i){return Math.round(e/i)+"h"}if(e>=n){return Math.round(e/n)+"m"}if(e>=r){return Math.round(e/r)+"s"}return e+"ms"}function l(e){return c(e,o,"day")||c(e,i,"hour")||c(e,n,"minute")||c(e,r,"second")||e+" ms"}function c(e,t,r){if(e<t){return}if(e<t*1.5){return Math.floor(e/t)+" "+r}return Math.ceil(e/t)+" "+r+"s"}},function(e,t){e.exports='<div class="advanced-slicer">\n    <div class="slicer-options">\n        <input class="searchbox" placeholder="Search" />\n        <span class="clear-all">Clear All</span>\n        <div style="margin:0;padding:0;margin-top:5px;">\n        <div class="selection-container">\n            <div class="selections">\n            </div>\n        </div>\n        <!-- Disabled -->\n        <label style="display:none;vertical-align:middle">\n            <input class="check-all" type="checkbox" style="margin-right:5px;vertical-align:middle"/>&nbsp;Select All\n        </label>\n        </div>\n        <hr/>\n    </div>\n    <div class="list">\n        <div class=\'load-spinner\'><div>\n    </div>\n</div>'},function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:true});var r=function(){function e(){this.listeners={}}e.prototype.on=function(e,t){var r=this;var n=this.listeners[e]=this.listeners[e]||[];n.push(t);return{destroy:function(){r.off(e,t)}}};e.prototype.off=function(e,t){var r=this.listeners[e];if(r){var n=r.indexOf(t);if(n>=0){r.splice(n,1)}}};e.prototype.raiseEvent=function(e){var t=this;var r=[];for(var n=1;n<arguments.length;n++){r[n-1]=arguments[n]}var i=this.listeners[e];if(i){i.forEach(function(e){e.apply(t,r)})}};return e}();t.default=r},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:true});var n=r(207);var i=r(7);var o=r(6);var a=r(83);var s=r(38);var u=r(209);var l=r(82);var c=r(195);var f=r(210);var d=r(193)("essex.widget.AttributeSlicer");var p=r(196);var h=function(){function e(t,r,s){var c=this;this._data=[];this._eventEmitter=new n.default;this.loadingSearch=false;this.loadingState=false;this.searchDebounce=l.SEARCH_DEBOUNCE;this.destroyed=false;this._leftAlignText=false;this._displayValueLables=false;this._overflowValueLabels=false;this._itemTextColor="#000";this.updateListHeight=o.debounce(function(){if(!c.destroyed&&c.dimensions){var e=c.dimensions.height-(c.listEle.offset().top-c.element.offset().top)-2;var t="100%";c.listEle.css({width:t,height:e});c.virtualList.setHeight(e);c.virtualList.setDir(c.renderHorizontal)}},50);this._showOptions=true;this._showSearchBox=true;this._serverSideSearch=true;this._caseInsentitive=true;this._renderHorizontal=false;this._valueWidthPercentage=l.DEFAULT_VALUE_WIDTH;this._showValues=false;this._showSelections=true;this._fontSize=l.DEFAULT_TEXT_SIZE;this._searchString="";this._loadingMoreData=false;this._toggleClass=o.debounce(function(){return c.element.toggleClass("loading",c.loadingMoreData)},100);this.element=t;this.showSelections=true;this.slicerEle=t.append(i(e.template)).find(".advanced-slicer");this.listEle=this.slicerEle.find(".list");this.searchDebounce=p(r,"searchDebounce",l.SEARCH_DEBOUNCE);this.virtualList=s||new f({itemHeight:this.fontSize*2,afterRender:function(){return c.selectionManager.refresh()},generatorFn:function(e){var t=c.virtualList.items[e];var r=u.default(t,c.calcColumnSizes(),c.leftAlignText,c.displayValueLabels,c.itemTextColor,c.overflowValueLabels);r.css({height:c.virtualList.itemHeight-4+"px",paddingBottom:"2.5px",paddingTop:"2px"}).data("item",t);if(t.onCreate){t.onCreate(r)}return r[0]}});this.selectionManager=new a.default(function(e){c.syncSelectionTokens(e);c.raiseSelectionChanged(e)});this.element.toggleClass("show-selections",this.showSelections);this.selectionManager.bindTo(this.listEle,".item",function(e){return e.data("item")},function(e){return c.listEle.find(".item").filter(function(t,r){return i(r).data("item").id===e.id})});this.fontSize=this.fontSize;this.virtualListEle=this.virtualList.container;var d=o.debounce(function(e){c.events.raiseEvent("scroll",e)},500);this.virtualListEle.scroll(function(e){var t=[e.target.scrollTop,e.target.scrollLeft];d(t);c.checkLoadMoreData()});this.listEle.append(this.virtualListEle);this.selectionsEle=t.find(".selections");this.checkAllEle=t.find(".check-all").on("click",function(){return c.toggleSelectAll()});this.clearAllEle=t.find(".clear-all").on("click",function(){c.search("");c.clearSelection()});this.attachEvents();this.brushSelectionMode=false;this.loadingMoreData=true}Object.defineProperty(e.prototype,"leftAlignText",{get:function(){return this._leftAlignText},set:function(e){if(e!==this._leftAlignText){this._leftAlignText=e;if(this.virtualList){this.virtualList.rerender()}}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"displayValueLabels",{get:function(){return this._displayValueLables},set:function(e){if(e!==this._displayValueLables){this._displayValueLables=e;if(this.virtualList){this.virtualList.rerender()}}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"overflowValueLabels",{get:function(){return this._overflowValueLabels},set:function(e){if(e!==this._overflowValueLabels){this._overflowValueLabels=e;if(this.virtualList){this.virtualList.rerender()}}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"itemTextColor",{get:function(){return this._itemTextColor},set:function(e){if(e!==this._itemTextColor){this._itemTextColor=e;if(this.virtualList){this.virtualList.rerender()}}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"state",{get:function(){return{selectedItems:this.selectedItems.map(function(e){return o.cloneDeep(e)}),searchText:this.searchString||"",labelDisplayUnits:0,labelPrecision:0,horizontal:this.renderHorizontal,valueColumnWidth:this.valueWidthPercentage,showSelections:this.showSelections,singleSelect:this.singleSelect,brushMode:this.brushSelectionMode,textSize:this.fontSize,leftAlignText:this.leftAlignText,showOptions:this.showOptions,showSearch:this.showSearchBox,searchSupported:this.showSearchBox,showValues:this.showValues,scrollPosition:this.scrollPosition,displayValueLabels:this.displayValueLabels,itemTextColor:this.itemTextColor,overflowValueLabels:this.overflowValueLabels}},set:function(e){this.loadingState=true;e=o.merge({},o.cloneDeep(l.DEFAULT_STATE),e);var t=this;t.singleSelect=e.singleSelect;t.brushSelectionMode=e.brushMode;t.showSelections=e.showSelections;t.showOptions=e.showOptions;t.showSearchBox=e.showSearch&&e.searchSupported;t.showValues=e.showValues;var r=e.searchText;var n=false;if(r!==t.searchString){n=true;t.searchString=r}t.fontSize=e.textSize;this.selectedItems=(e.selectedItems||[]).map(function(e){return o.merge({},e,{equals:function(t){return t.id===e.id}})});t.renderHorizontal=e.horizontal;t.valueWidthPercentage=e.valueColumnWidth;this.scrollPosition=e.scrollPosition;this.leftAlignText=e.leftAlignText;this.displayValueLabels=e.displayValueLabels;this.itemTextColor=e.itemTextColor;this.overflowValueLabels=e.overflowValueLabels;this.loadingState=false},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"scrollPosition",{get:function(){var e=this.virtualListEle;if(e){return[e.scrollTop(),e.scrollLeft()]}else{return[0,0]}},set:function(e){var t=this.virtualListEle;if(t){t.scrollTop(e[0]);t.scrollLeft(e[1])}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"showOptions",{get:function(){return this._showOptions},set:function(e){this._showOptions=e;this.syncUIVisibility()},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"showSearchBox",{get:function(){return this._showSearchBox},set:function(e){this._showSearchBox=e;this.syncUIVisibility()},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"serverSideSearch",{get:function(){return this._serverSideSearch},set:function(e){this._serverSideSearch=e},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"singleSelect",{get:function(){return this.selectionManager.singleSelect},set:function(e){if(e!==this.selectionManager.singleSelect){this.selectionManager.singleSelect=e}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"brushSelectionMode",{get:function(){return this.selectionManager.brushMode},set:function(e){if(e!==this.selectionManager.brushMode){this.selectionManager.brushMode=e;this.element.toggleClass("brush-mode",e)}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"caseInsensitive",{get:function(){return this._caseInsentitive},set:function(e){this._caseInsentitive=e;this.syncItemVisiblity()},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"events",{get:function(){return this._eventEmitter},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"renderHorizontal",{get:function(){return this._renderHorizontal},set:function(e){if(e!==this._renderHorizontal){this._renderHorizontal=e;this.element.toggleClass("render-horizontal",e);this.updateListHeight()}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"dimensions",{get:function(){return this._dimensions},set:function(e){this._dimensions=e;this.updateListHeight()},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"valueWidthPercentage",{get:function(){return this._valueWidthPercentage},set:function(e){e=e?Math.max(Math.min(e,100),10):l.DEFAULT_VALUE_WIDTH;if(e!==this._valueWidthPercentage){this._valueWidthPercentage=e;this.resizeColumns()}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"showValues",{get:function(){return this._showValues},set:function(e){if(e!==this._showValues){this._showValues=e;this.element.toggleClass("has-values",e)}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"showSelections",{get:function(){return this._showSelections},set:function(e){if(e!==this._showSelections){this._showSelections=e;this.element.toggleClass("show-selections",e);this.syncItemVisiblity()}},enumerable:true,
configurable:true});Object.defineProperty(e.prototype,"showHighlight",{get:function(){return this.element.hasClass("show-highlight")},set:function(e){this.element.toggleClass("show-highlight",!!e)},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"data",{get:function(){return this._data},set:function(e){var t=this;if(!this.loadingMoreData){this.selectedItems=[]}if(e&&e.length){this.search(this.searchString)}this._data=e;this.selectionManager.items=e;this.syncItemVisiblity(true);this.updateSelectAllButtonState();if(!this.loadingMoreData){setTimeout(function(){return t.checkLoadMoreData()},10)}this.loadingMoreData=false},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"fontSize",{get:function(){return this._fontSize},set:function(e){e=e||l.DEFAULT_TEXT_SIZE;if(e!==this._fontSize){this._fontSize=e;this.slicerEle.css({fontSize:this._fontSize+"px"});if(this.virtualList){this.virtualList.setItemHeight(this._fontSize*2)}}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"selectedItems",{get:function(){return this.selectionManager.selection},set:function(e){this.selectionManager.selection=e;this.syncSelectionTokens(e)},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"searchString",{get:function(){return this._searchString},set:function(e){e=e||"";if(e!==this._searchString){this._searchString=e||"";this.loadingSearch=true;this.element.find(".searchbox").val(e);this.loadingSearch=false;this.syncUIVisibility(false)}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"loadingMoreData",{get:function(){return this._loadingMoreData},set:function(e){this._loadingMoreData=e;if(e){this.element.addClass("loading")}this._toggleClass()},enumerable:true,configurable:true});e.isMatch=function(t,r,n){var i=s.prettyPrintValue(r);var o=n?"i":"";var a=new RegExp(e.escapeRegExp(i),o);return a.test(s.prettyPrintValue(t.match))||a.test(s.prettyPrintValue(t.matchPrefix))||a.test(s.prettyPrintValue(t.matchSuffix))};e.escapeRegExp=function(e){return e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")};e.prototype.calcColumnSizes=function(){var e=100-this.valueWidthPercentage;return{value:this.showValues?this.valueWidthPercentage:0,category:this.showValues?e:100}};e.prototype.destroy=function(){this.destroyed=true;if(this.selectionManager){this.selectionManager.destroy()}};e.prototype.search=function(e){var t=this;if(this.searchString!==e){this.searchString=e;if(this.serverSideSearch){var r=this.loadingMoreData;this.loadingMoreData=true;setTimeout(function(){if(!t.checkLoadMoreDataBasedOnSearch()){t.loadingMoreData=r}},10)}this.raiseSearchPerformed(e)}this.syncItemVisiblity();this.element.toggleClass("has-search",!!this.searchString)};e.prototype.refresh=function(){if(this.virtualList){this.virtualList.rerender()}};e.prototype.sort=function(e,t){this.data.sort(function(r,n){var i=c(r[e],n[e]);return t?-1*i:i})};e.prototype.checkLoadMoreData=function(){var e=this.virtualListEle[0];var t=this.renderHorizontal?"Width":"Height";var r=this.renderHorizontal?"Left":"Top";var n=e["scroll"+t];var i=e["scroll"+r];var o=n-(i+e["client"+t])<200;if(o&&!this.loadingMoreData&&this.raiseCanLoadMoreData()){this.raiseLoadMoreData(false)}};e.prototype.raiseSearchPerformed=function(e){this.events.raiseEvent("searchPerformed",e)};e.prototype.raiseLoadMoreData=function(e){var t=this;var r={};this.events.raiseEvent("loadMoreData",r,e,this.searchString);if(r.result){this.loadingMoreData=true;var n=this.loadPromise=r.result.then(function(r){if(!n||!n["cancel"]){t.loadPromise=undefined;if(e){t.data=r}else{t.data=t.data.concat(r)}setTimeout(function(){t.checkLoadMoreData();if(!t.loadPromise){t.loadingMoreData=false}},10);return r}},function(){t.loadingMoreData=false});return n}else{this.loadingMoreData=false}};e.prototype.raiseCanLoadMoreData=function(e){if(e===void 0){e=false}var t={result:false};this.events.raiseEvent("canLoadMoreData",t,e);return t.result};e.prototype.raiseSelectionChanged=function(e){this.events.raiseEvent("selectionChanged",e)};e.prototype.resizeColumns=function(){var e=this.calcColumnSizes();this.element.find(".value-container").css({maxWidth:e.value+"%"});this.element.find(".category-container").css({maxWidth:e.category+"%"})};e.prototype.syncSelectionTokens=function(e){var t=this;if(e){this.selectionsEle.find(".token").remove();e.map(function(e){return t.createSelectionToken(e)}).forEach(function(e){return e.appendTo(t.element.find(".selections"))})}if(this.showSelections){this.syncItemVisiblity()}this.syncUIVisibility()};e.prototype.syncItemVisiblity=function(t){var r=this;if(t===void 0){t=false}var n=[];if(this.data&&this.data.length){n=this.data.filter(function(t,n){var i=r.data[n];var o=!r.showSelections||!(!!r.selectedItems&&r.selectedItems.filter(function(e){return e.equals(i)}).length>0);if(o&&!r.serverSideSearch&&r.searchString){o=e.isMatch(i,r.searchString,r.caseInsensitive)}return o})}if(this.virtualList&&(t||n.length!==(this.virtualList.items||[]).length)){this.virtualList.setItems(n)}};e.prototype.syncUIVisibility=function(e){if(e===void 0){e=true}var t=!!(this.selectedItems&&this.selectedItems.length);this.element.find(".slicer-options").toggle(this.showOptions);this.element.find(".searchbox").toggle(this.showSearchBox);this.element.find(".slicer-options").toggle(this.showOptions&&(this.showSearchBox||t));this.clearAllEle.toggle(t||!!this.searchString);if(!this.showSearchBox){this.searchString=""}if(e){this.updateListHeight()}};e.prototype.toggleSelectAll=function(){var e=this.checkAllEle.prop("checked");if(!!e){this.selectedItems=this._data.slice(0)}else{this.selectedItems=[]}};e.prototype.createSelectionToken=function(e){var t=this;var r=i("<div/>");var n=s.prettyPrintValue(e.matchPrefix)+s.prettyPrintValue(e.match)+s.prettyPrintValue(e.matchSuffix);r.addClass("token").attr("title",n).data("item",e).on("click",function(){r.remove();var n=t.selectedItems.filter(function(t){return t.equals(e)})[0];var i=t.selectedItems.slice(0);i.splice(i.indexOf(n),1);t.selectedItems=i}).text(n);return r};e.prototype.clearSelection=function(){this.selectedItems=[]};e.prototype.updateSelectAllButtonState=function(){this.checkAllEle.prop("indeterminate",this.selectedItems.length>0&&this._data.length!==this.selectedItems.length);this.checkAllEle.prop("checked",this.selectedItems.length>0)};e.prototype.attachEvents=function(){var e=this;var t=o.debounce(function(){return e.search(e.getSearchStringFromElement())},this.searchDebounce);this.element.find(".searchbox").on("input",function(){if(!e.loadingSearch){t()}});this.listEle.on("click",function(e){e.stopImmediatePropagation();e.stopPropagation()})};e.prototype.getSearchStringFromElement=function(){return this.element.find(".searchbox").val()||""};e.prototype.checkLoadMoreDataBasedOnSearch=function(){if(this.raiseCanLoadMoreData(true)){if(this.loadPromise){this.loadPromise["cancel"]=true}this.loadingMoreData=false;this.raiseLoadMoreData(true);return true}};return e}();h.template=r(206);t.AttributeSlicer=h},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:true});var n=r(38);var i=r(7);var o=r(86);function a(e,t,r,o,a,u){"use strict";var l=e.match,c=e.matchPrefix,f=e.matchSuffix,d=e.valueSegments,p=e.renderedValue;var h=r?"text-align:left;":"";var v=a?a:"#000";var g="display:inline-block;overflow:hidden;max-width:"+t.category+"%;"+h+";color:"+v;var y=i(('\n        <div style="white-space:nowrap" class="item" style="cursor:pointer">\n            <div style="margin-left: 5px;vertical-align:middle;height:100%" class="display-container">\n                <span style="'+g+'" title="" class="category-container">\n                    <span class="matchPrefix">'+n.prettyPrintValue(c)+'</span>\n                    <span class="match"></span>\n                    <span class="matchSuffix">'+n.prettyPrintValue(f)+'</span>\n                </span>\n                <span style="display:inline-block;max-width:'+t.value+'%;height:100%" class="value-container">\n                    <span style="display:inline-block;width:'+p+'%;height:100%">\n                    '+s(d,o,u)+"\n                    </span>\n                </span>\n            </div>\n        </div>\n    ").trim().replace(/\n/g,""));y[0].querySelector(".match").textContent=n.prettyPrintValue(l);y[0].querySelector(".category-container").setAttribute("title",n.prettyPrintValue(l));return y}t.default=a;function s(e,t,r){"use strict";return(e||[]).filter(function(e){return e.width>0}).map(function(e){var n=e.color,i=e.highlightWidth;var a="";var s="#333";if(n){a="background-color:"+n+";";var l=o.hcl(n);if(l.l<=60){s="#ececec"}}if(typeof i==="number"){var c=o.rgb(n),f=c.r,d=c.g,p=c.b;a="background-color:rgba("+f+", "+d+", "+p+", .2)";s="#333"}else if(e.value&&e.value<0){var h=o.rgb(n).darker();a="background:repeating-linear-gradient(45deg,"+n+","+n+" 10px,"+h+" 10px,"+h+" 20px)"}var v=e.displayValue||e.value||"0";var g="display:inline-block;width:"+e.width+"%;"+a+";height:100%;position:relative;color:"+s;var y="value-display";var m=t?"always-display value":"value";if(r){y+=" overflow";m+=" overflow"}return('\n            <span style="'+g+'" title="'+((e["name"]?e["name"]+" - ":"")+v)+'" class="'+y+'" >\n                '+u(e)+'\n                &nbsp;<span class="'+m+'">'+v+"</span>\n            </span>\n        ").trim().replace(/\n/g,"")}).join("")}function u(e){"use strict";var t=e.highlightWidth,r=e.color;if(typeof t==="number"){var n="";if(r){n="background-color:"+r+";"}var i=n+"position:absolute;left:0;top:0;bottom:0;width:"+t+"%;";return'<span class="value-display-highlight" style="'+i+'"></span>'}return""}},function(e,t,r){"use strict";var n=r(7);var i=r(6);function o(e){var t=e&&e.w+"px"||"100%";var r=e&&e.h+"px"||"100%";this.itemHeight=e.itemHeight;this.generatorFn=e.generatorFn;this.afterRender=e.afterRender;var a=o.createScroller(0);var s=this.listContainer=n("<div class='list-display'>");this.scroller=a;this.container=o.createContainer(t,r);this.container.append(s);this.container.append(a);var u=this;this.rmNodeInterval=setInterval(function(){if(Date.now()-this.lastScrolled>100){var e=u.container.find("[data-rm]");if(e.length){e.remove()}}}.bind(this),300);var l=function(e){var t=e.target[this.scrollProp];if(!this.lastRepaintPos||Math.abs(t-this.lastRepaintPos)>this.maxBuffer){var r=parseInt(t/this.itemHeight)-this.screenItemsLen;u._renderChunk(u.listContainer,r<0?0:r);this.lastRepaintPos=t}this.lastScrolled=Date.now();e.preventDefault&&e.preventDefault()}.bind(this);this.container.on("scroll",l.bind(this));this._renderChunkDebounced=i.debounce(o.prototype._renderChunk,50)}o.prototype.setDir=function(e){var t=this.itemHeight*this.totalRows;var r=this.container.height();var n=this.container.width();this.horiz=e;if(e){this.scrollProp="scrollLeft";this.scroller.css({width:t+"px",height:"1px"});this.listContainer.css({transform:"rotate(-90deg) translateX(-"+(r-5)+"px)",transformOrigin:"0px 0px",height:n+"px",width:r+"px"});this.container.css({overflowX:"auto",overflowY:"hidden"}).scrollTop(0)}else{this.scrollProp="scrollTop";this.scroller.css({width:"1px",height:t+"px"});this.listContainer.css({transform:"",transformOrigin:"",width:n+"px",height:r+"px"});this.container.css({overflowX:"hidden",overflowY:"auto"}).scrollLeft(0)}var i=this.screenItemsLen=Math.ceil((this.horiz?n:r)/this.itemHeight);this.cachedItemsLen=i*3;this.maxBuffer=i*this.itemHeight;this.lastRepaintPos=undefined;if(this.items){var o=parseInt(this.container[0][this.scrollProp]/this.itemHeight)-this.screenItemsLen;this._renderChunkDebounced(this.listContainer,o<0?0:o)}};o.prototype.setHeight=function(e){this.container.css({height:e});var t=this.screenItemsLen=Math.ceil((this.horiz?this.container.width():e)/this.itemHeight);this.cachedItemsLen=t*3;this.maxBuffer=t*this.itemHeight;this.lastRepaintPos=undefined;if(this.items){var r=parseInt(this.container[0][this.scrollProp]/this.itemHeight)-this.screenItemsLen;this._renderChunkDebounced(this.listContainer,r<0?0:r)}};o.prototype.setItemHeight=function(e){this.itemHeight=e;var t=this.screenItemsLen=Math.ceil((this.horiz?this.container.width():this.container.height())/this.itemHeight);this.cachedItemsLen=t*3;this.maxBuffer=t*this.itemHeight;var r={};r[this.horiz?"width":"height"]=this.itemHeight*this.totalRows+"px";this.scroller.css(r);this.lastRepaintPos=undefined;if(this.items){var n=parseInt(this.container[0][this.scrollProp]/this.itemHeight)-this.screenItemsLen;this._renderChunkDebounced(this.listContainer,n<0?0:n)}};o.prototype.setItems=function(e){this.items=e;this.totalRows=e&&e.length;var t={};t[this.horiz?"width":"height"]=this.itemHeight*this.totalRows+"px";this.scroller.css(t);this.lastRepaintPos=undefined;this.lastScrolled=0;this._renderChunkDebounced(this.listContainer,0)};o.prototype.createRow=function(e){var t;if(this.generatorFn)t=this.generatorFn(e);else if(this.items){if(typeof this.items[e]==="string"){var r=document.createTextNode(this.items[e]);t=document.createElement("div");t.style.height=this.itemHeight+"px";t.appendChild(r)}else{t=this.items[e]}}if(t){t.classList.add("vrow");t.style.position="absolute";t.style.top=e*this.itemHeight+"px"}return t};o.prototype.rerender=i.debounce(function(){var e=parseInt(this.container[0][this.scrollProp]/this.itemHeight)-this.screenItemsLen;this._renderChunk(this.listContainer,e<0?0:e);this.lastScrolled=0},100);o.prototype._renderChunk=function(e,t){var r=t+this.cachedItemsLen;if(r>this.totalRows)r=this.totalRows;var i=n("<div>");for(var o=t;o<r&&o<this.totalRows;o++){var a=this.createRow(o);i.append(a)}for(var s=0,u=e[0].childNodes.length;s<u;s++){e[0].childNodes[s].style.display="none";e[0].childNodes[s].setAttribute("data-rm","1")}e.append(i);if(this.afterRender){this.afterRender()}};o.createContainer=function(e,t){var r=n("<div>");r.addClass("virtual-list");r.css({width:"100%",height:"100%",overflow:"hidden",overflowY:"auto",position:"relative",padding:0});return r};o.createScroller=function(e){var t=n("<div>");t.addClass("vlist-scroller");t.css({opacity:0,position:"absolute",top:0,left:0,width:"1px",height:e+"px"});return t};e.exports=o}]);